/*
 *                          Yeppp! library header
 *
 * This file is part of Yeppp! library and licensed under 2-clause BSD license.
 *
 * Copyright (C) 2010-2012 Marat Dukhan
 * Copyright (C) 2012-2013 Georgia Institute of Technology
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software and documentation are those
 * of the authors and should not be interpreted as representing official policies,
 * either expressed or implied, of the Yeppp! Project.
 */

#pragma once

#define YEP_MAJOR_VERSION 0
#define YEP_MINOR_VERSION 9
#define YEP_PATCH_VERSION 6
#define YEP_BUILD_VERSION 1
#define YEP_RELEASE_NAME "Technology Preview 6"

#define YEP_PREPROCESSOR_NUMBER_AS_STRING_HELPER(number) #number
#define YEP_PREPROCESSOR_NUMBER_AS_STRING(number) YEP_PREPROCESSOR_NUMBER_AS_STRING_HELPER(number)

#define YEP_MAJOR_VERSION_STR       YEP_PREPROCESSOR_NUMBER_AS_STRING(YEP_MAJOR_VERSION)
#define YEP_MINOR_VERSION_STR       YEP_PREPROCESSOR_NUMBER_AS_STRING(YEP_MINOR_VERSION)
#define YEP_PATCH_VERSION_STR       YEP_PREPROCESSOR_NUMBER_AS_STRING(YEP_PATCH_VERSION)
#define YEP_BUILD_VERSION_STR       YEP_PREPROCESSOR_NUMBER_AS_STRING(YEP_BUILD_VERSION)

#define YEP_FULL_VERSION_STR YEP_MAJOR_VERSION_STR "." YEP_MINOR_VERSION_STR "." YEP_PATCH_VERSION_STR "." YEP_BUILD_VERSION_STR " (" YEP_RELEASE_NAME ")"
