section .text$4 code align=16
global _yepCore_Multiply_V16uV16u_V16u_Nehalem
_yepCore_Multiply_V16uV16u_V16u_Nehalem:
	.ENTRY:
	PUSH rbx                                                               ; 
	SUB rsp, 32                                                            ; 
	MOVAPS [rsp], xmm6                                                     ; 
	MOVAPS [byte rsp + 16], xmm7                                           ; 
	.yM16:
	TEST rdx, 15                                                           ; 
	JZ .yA16                                                               ; 
	MOVZX eax, word [rcx]                                                  ; 
	MOVZX ebx, word [rdx]                                                  ; 
	IMUL eax, ebx                                                          ; 
	MOV [r8], ax                                                           ; 
	ADD rcx, 2                                                             ; 
	ADD rdx, 2                                                             ; 
	ADD r8, 2                                                              ; 
	SUB r9, 1                                                              ; 
	JZ .return_ok                                                          ; 
	JMP .yM16                                                              ; 
	.yA16:
	SUB r9, 64                                                             ; r8, r9, rcx, rdx, rsp
	JB .yA16_restore                                                       ; r8, r9, rcx, rdx, rsp
	MOVDQU xmm0, [rcx]                                                     ; r8, r9, rcx, rdx, rsp
	MOVDQU xmm1, [byte rcx + 16]                                           ; r8, r9, rcx, rdx, rsp, xmm0
	MOVDQU xmm2, [byte rcx + 32]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1
	MOVDQU xmm3, [byte rcx + 48]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2
	MOVDQU xmm4, [byte rcx + 64]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3
	PMULLW xmm0, [rdx]                                                     ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	MOVDQU xmm5, [byte rcx + 80]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	PMULLW xmm1, [byte rdx + 16]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	MOVDQU xmm6, [byte rcx + 96]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	PMULLW xmm2, [byte rdx + 32]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	MOVDQU xmm7, [byte rcx + 112]                                          ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	PMULLW xmm3, [byte rdx + 48]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	SUB rcx, -128                                                          ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	SUB r9, 64                                                             ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	JB .skip_SWP                                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	align 16
	.yA16_loop:
	MOVDQU [r8], xmm0                                                      ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVDQU xmm0, [rcx]                                                     ; r8, r9, rcx, rdx, rsp, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	PMULLW xmm4, [byte rdx + 64]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVDQU [byte r8 + 16], xmm1                                            ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVDQU xmm1, [byte rcx + 16]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	PMULLW xmm5, [byte rdx + 80]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVDQU [byte r8 + 32], xmm2                                            ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVDQU xmm2, [byte rcx + 32]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm3, xmm4, xmm5, xmm6, xmm7
	PMULLW xmm6, [byte rdx + 96]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVDQU [byte r8 + 48], xmm3                                            ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVDQU xmm3, [byte rcx + 48]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm4, xmm5, xmm6, xmm7
	PMULLW xmm7, [byte rdx + 112]                                          ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	SUB rdx, -128                                                          ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVDQU [byte r8 + 64], xmm4                                            ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVDQU xmm4, [byte rcx + 64]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm5, xmm6, xmm7
	PMULLW xmm0, [rdx]                                                     ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVDQU [byte r8 + 80], xmm5                                            ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVDQU xmm5, [byte rcx + 80]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm6, xmm7
	PMULLW xmm1, [byte rdx + 16]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVDQU [byte r8 + 96], xmm6                                            ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVDQU xmm6, [byte rcx + 96]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm7
	PMULLW xmm2, [byte rdx + 32]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVDQU [byte r8 + 112], xmm7                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVDQU xmm7, [byte rcx + 112]                                          ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	PMULLW xmm3, [byte rdx + 48]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	SUB rcx, -128                                                          ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	SUB r8, -128                                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	SUB r9, 64                                                             ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	JAE .yA16_loop                                                         ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	.skip_SWP:
	MOVDQU [r8], xmm0                                                      ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	PMULLW xmm4, [byte rdx + 64]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVDQU [byte r8 + 16], xmm1                                            ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	PMULLW xmm5, [byte rdx + 80]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVDQU [byte r8 + 32], xmm2                                            ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	PMULLW xmm6, [byte rdx + 96]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVDQU [byte r8 + 48], xmm3                                            ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	PMULLW xmm7, [byte rdx + 112]                                          ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	SUB rdx, -128                                                          ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVDQU [byte r8 + 64], xmm4                                            ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	PMULLW xmm0, [rdx]                                                     ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm5, xmm6, xmm7
	MOVDQU [byte r8 + 80], xmm5                                            ; r8, r9, rcx, rdx, rsp, xmm1, xmm2, xmm3, xmm5, xmm6, xmm7
	PMULLW xmm1, [byte rdx + 16]                                           ; r8, r9, rcx, rdx, rsp, xmm1, xmm2, xmm3, xmm6, xmm7
	MOVDQU [byte r8 + 96], xmm6                                            ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm6, xmm7
	PMULLW xmm2, [byte rdx + 32]                                           ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm7
	MOVDQU [byte r8 + 112], xmm7                                           ; r8, r9, rcx, rdx, rsp, xmm3, xmm7
	PMULLW xmm3, [byte rdx + 48]                                           ; r8, r9, rcx, rdx, rsp, xmm3
	SUB r8, -128                                                           ; r8, r9, rcx, rdx, rsp
	.yA16_restore:
	ADD r9, 64                                                             ; r8, r9, rcx, rdx, rsp
	JZ .return_ok                                                          ; r8, r9, rcx, rdx, rsp
	.finalize:
	MOVZX eax, word [rcx]                                                  ; r8, r9, rcx, rdx, rsp
	MOVZX ebx, word [rdx]                                                  ; eax, r8, r9, rcx, rdx, rsp
	IMUL eax, ebx                                                          ; eax, ebx, r8, r9, rcx, rdx, rsp
	MOV [r8], ax                                                           ; ax, r8, r9, rcx, rdx, rsp
	ADD rcx, 2                                                             ; r8, r9, rcx, rdx, rsp
	ADD rdx, 2                                                             ; r8, r9, rdx, rsp
	ADD r8, 2                                                              ; r8, r9, rsp
	SUB r9, 1                                                              ; r9, rsp
	JNZ .finalize                                                          ; rsp
	.return_ok:
	XOR eax, eax                                                           ; rsp
	.return:
	MOVAPS xmm7, [rsp]                                                     ; 
	MOVAPS xmm6, [byte rsp + 16]                                           ; 
	ADD rsp, 32                                                            ; 
	POP rbx                                                                ; 
	RET                                                                    ; rsp

section .text$4 code align=16
global _yepCore_Multiply_V16uV16u_V32u_Nehalem
_yepCore_Multiply_V16uV16u_V32u_Nehalem:
	.ENTRY:
	PUSH rbx                                                               ; 
	SUB rsp, 16                                                            ; 
	MOVAPS [rsp], xmm6                                                     ; 
	.zM16:
	TEST r8, 15                                                            ; 
	JZ .zA16                                                               ; 
	MOVZX eax, word [rcx]                                                  ; 
	MOVZX ebx, word [rdx]                                                  ; 
	IMUL eax, ebx                                                          ; 
	MOV [r8], eax                                                          ; 
	ADD rcx, 2                                                             ; 
	ADD rdx, 2                                                             ; 
	ADD r8, 4                                                              ; 
	SUB r9, 1                                                              ; 
	JZ .return_ok                                                          ; 
	JMP .zM16                                                              ; 
	.zA16:
	SUB r9, 16                                                             ; r8, r9, rcx, rdx, rsp
	JB .zA16_restore                                                       ; r8, r9, rcx, rdx, rsp
	align 16
	.zA16_loop:
	MOVDQU xmm0, [rcx]                                                     ; r8, r9, rcx, rdx, rsp
	MOVDQU xmm1, [rdx]                                                     ; r8, r9, rcx, rdx, rsp, xmm0
	MOVDQA xmm2, xmm0                                                      ; r8, r9, rcx, rdx, rsp, xmm0, xmm1
	PMULLW xmm0, xmm1                                                      ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2
	PMULHUW xmm2, xmm1                                                     ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2
	MOVDQA xmm1, xmm0                                                      ; r8, r9, rcx, rdx, rsp, xmm0, xmm2
	PUNPCKLWD xmm0, xmm2                                                   ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2
	PUNPCKHWD xmm1, xmm2                                                   ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2
	MOVDQA [r8], xmm0                                                      ; r8, r9, rcx, rdx, rsp, xmm0, xmm1
	MOVDQA [byte r8 + 16], xmm1                                            ; r8, r9, rcx, rdx, rsp, xmm1
	MOVDQU xmm4, [byte rcx + 16]                                           ; r8, r9, rcx, rdx, rsp
	MOVDQU xmm5, [byte rdx + 16]                                           ; r8, r9, rcx, rdx, rsp, xmm4
	MOVDQA xmm6, xmm4                                                      ; r8, r9, rcx, rdx, rsp, xmm4, xmm5
	PMULLW xmm4, xmm5                                                      ; r8, r9, rcx, rdx, rsp, xmm4, xmm5, xmm6
	PMULHUW xmm6, xmm5                                                     ; r8, r9, rcx, rdx, rsp, xmm4, xmm5, xmm6
	MOVDQA xmm5, xmm4                                                      ; r8, r9, rcx, rdx, rsp, xmm4, xmm6
	PUNPCKLWD xmm4, xmm6                                                   ; r8, r9, rcx, rdx, rsp, xmm4, xmm5, xmm6
	PUNPCKHWD xmm5, xmm6                                                   ; r8, r9, rcx, rdx, rsp, xmm4, xmm5, xmm6
	MOVDQA [byte r8 + 32], xmm4                                            ; r8, r9, rcx, rdx, rsp, xmm4, xmm5
	MOVDQA [byte r8 + 48], xmm5                                            ; r8, r9, rcx, rdx, rsp, xmm5
	ADD rcx, 32                                                            ; r8, r9, rcx, rdx, rsp
	ADD rdx, 32                                                            ; r8, r9, rcx, rdx, rsp
	ADD r8, 64                                                             ; r8, r9, rcx, rdx, rsp
	SUB r9, 16                                                             ; r8, r9, rcx, rdx, rsp
	JAE .zA16_loop                                                         ; r8, r9, rcx, rdx, rsp
	.zA16_restore:
	ADD r9, 16                                                             ; r8, r9, rcx, rdx, rsp
	JZ .return_ok                                                          ; r8, r9, rcx, rdx, rsp
	.finalize:
	MOVZX eax, word [rcx]                                                  ; r8, r9, rcx, rdx, rsp
	MOVZX ebx, word [rdx]                                                  ; eax, r8, r9, rcx, rdx, rsp
	IMUL eax, ebx                                                          ; eax, ebx, r8, r9, rcx, rdx, rsp
	MOV [r8], eax                                                          ; eax, r8, r9, rcx, rdx, rsp
	ADD rcx, 2                                                             ; r8, r9, rcx, rdx, rsp
	ADD rdx, 2                                                             ; r8, r9, rdx, rsp
	ADD r8, 4                                                              ; r8, r9, rsp
	SUB r9, 1                                                              ; r9, rsp
	JNZ .finalize                                                          ; rsp
	.return_ok:
	XOR eax, eax                                                           ; rsp
	.return:
	MOVAPS xmm6, [rsp]                                                     ; 
	ADD rsp, 16                                                            ; 
	POP rbx                                                                ; 
	RET                                                                    ; rsp

section .text$4 code align=16
global _yepCore_Multiply_V16sV16s_V32s_Nehalem
_yepCore_Multiply_V16sV16s_V32s_Nehalem:
	.ENTRY:
	PUSH rbx                                                               ; 
	SUB rsp, 16                                                            ; 
	MOVAPS [rsp], xmm6                                                     ; 
	.zM16:
	TEST r8, 15                                                            ; 
	JZ .zA16                                                               ; 
	MOVSX eax, word [rcx]                                                  ; 
	MOVSX ebx, word [rdx]                                                  ; 
	IMUL eax, ebx                                                          ; 
	MOV [r8], eax                                                          ; 
	ADD rcx, 2                                                             ; 
	ADD rdx, 2                                                             ; 
	ADD r8, 4                                                              ; 
	SUB r9, 1                                                              ; 
	JZ .return_ok                                                          ; 
	JMP .zM16                                                              ; 
	.zA16:
	SUB r9, 16                                                             ; r8, r9, rcx, rdx, rsp
	JB .zA16_restore                                                       ; r8, r9, rcx, rdx, rsp
	align 16
	.zA16_loop:
	MOVDQU xmm0, [rcx]                                                     ; r8, r9, rcx, rdx, rsp
	MOVDQU xmm1, [rdx]                                                     ; r8, r9, rcx, rdx, rsp, xmm0
	MOVDQA xmm2, xmm0                                                      ; r8, r9, rcx, rdx, rsp, xmm0, xmm1
	PMULLW xmm0, xmm1                                                      ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2
	PMULHW xmm2, xmm1                                                      ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2
	MOVDQA xmm1, xmm0                                                      ; r8, r9, rcx, rdx, rsp, xmm0, xmm2
	PUNPCKLWD xmm0, xmm2                                                   ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2
	PUNPCKHWD xmm1, xmm2                                                   ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2
	MOVDQA [r8], xmm0                                                      ; r8, r9, rcx, rdx, rsp, xmm0, xmm1
	MOVDQA [byte r8 + 16], xmm1                                            ; r8, r9, rcx, rdx, rsp, xmm1
	MOVDQU xmm4, [byte rcx + 16]                                           ; r8, r9, rcx, rdx, rsp
	MOVDQU xmm5, [byte rdx + 16]                                           ; r8, r9, rcx, rdx, rsp, xmm4
	MOVDQA xmm6, xmm4                                                      ; r8, r9, rcx, rdx, rsp, xmm4, xmm5
	PMULLW xmm4, xmm5                                                      ; r8, r9, rcx, rdx, rsp, xmm4, xmm5, xmm6
	PMULHW xmm6, xmm5                                                      ; r8, r9, rcx, rdx, rsp, xmm4, xmm5, xmm6
	MOVDQA xmm5, xmm4                                                      ; r8, r9, rcx, rdx, rsp, xmm4, xmm6
	PUNPCKLWD xmm4, xmm6                                                   ; r8, r9, rcx, rdx, rsp, xmm4, xmm5, xmm6
	PUNPCKHWD xmm5, xmm6                                                   ; r8, r9, rcx, rdx, rsp, xmm4, xmm5, xmm6
	MOVDQA [byte r8 + 32], xmm4                                            ; r8, r9, rcx, rdx, rsp, xmm4, xmm5
	MOVDQA [byte r8 + 48], xmm5                                            ; r8, r9, rcx, rdx, rsp, xmm5
	ADD rcx, 32                                                            ; r8, r9, rcx, rdx, rsp
	ADD rdx, 32                                                            ; r8, r9, rcx, rdx, rsp
	ADD r8, 64                                                             ; r8, r9, rcx, rdx, rsp
	SUB r9, 16                                                             ; r8, r9, rcx, rdx, rsp
	JAE .zA16_loop                                                         ; r8, r9, rcx, rdx, rsp
	.zA16_restore:
	ADD r9, 16                                                             ; r8, r9, rcx, rdx, rsp
	JZ .return_ok                                                          ; r8, r9, rcx, rdx, rsp
	.finalize:
	MOVSX eax, word [rcx]                                                  ; r8, r9, rcx, rdx, rsp
	MOVSX ebx, word [rdx]                                                  ; eax, r8, r9, rcx, rdx, rsp
	IMUL eax, ebx                                                          ; eax, ebx, r8, r9, rcx, rdx, rsp
	MOV [r8], eax                                                          ; eax, r8, r9, rcx, rdx, rsp
	ADD rcx, 2                                                             ; r8, r9, rcx, rdx, rsp
	ADD rdx, 2                                                             ; r8, r9, rdx, rsp
	ADD r8, 4                                                              ; r8, r9, rsp
	SUB r9, 1                                                              ; r9, rsp
	JNZ .finalize                                                          ; rsp
	.return_ok:
	XOR eax, eax                                                           ; rsp
	.return:
	MOVAPS xmm6, [rsp]                                                     ; 
	ADD rsp, 16                                                            ; 
	POP rbx                                                                ; 
	RET                                                                    ; rsp

section .text$4 code align=16
global _yepCore_Multiply_V32uV32u_V32u_Nehalem
_yepCore_Multiply_V32uV32u_V32u_Nehalem:
	.ENTRY:
	SUB rsp, 40                                                            ; 
	MOVAPS [rsp], xmm6                                                     ; 
	MOVAPS [byte rsp + 16], xmm7                                           ; 
	.yM16:
	TEST rdx, 15                                                           ; 
	JZ .yA16                                                               ; 
	MOV eax, [rcx]                                                         ; 
	IMUL eax, [rdx]                                                        ; 
	MOV [r8], eax                                                          ; 
	ADD rcx, 4                                                             ; 
	ADD rdx, 4                                                             ; 
	ADD r8, 4                                                              ; 
	SUB r9, 1                                                              ; 
	JZ .return_ok                                                          ; 
	JMP .yM16                                                              ; 
	.yA16:
	SUB r9, 32                                                             ; r8, r9, rcx, rdx, rsp
	JB .yA16_restore                                                       ; r8, r9, rcx, rdx, rsp
	MOVDQU xmm0, [rcx]                                                     ; r8, r9, rcx, rdx, rsp
	MOVDQU xmm1, [byte rcx + 16]                                           ; r8, r9, rcx, rdx, rsp, xmm0
	MOVDQU xmm2, [byte rcx + 32]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1
	MOVDQU xmm3, [byte rcx + 48]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2
	MOVDQU xmm4, [byte rcx + 64]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3
	PMULLD xmm0, [rdx]                                                     ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	MOVDQU xmm5, [byte rcx + 80]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	PMULLD xmm1, [byte rdx + 16]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	MOVDQU xmm6, [byte rcx + 96]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	PMULLD xmm2, [byte rdx + 32]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	MOVDQU xmm7, [byte rcx + 112]                                          ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	PMULLD xmm3, [byte rdx + 48]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	SUB rcx, -128                                                          ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	SUB r9, 32                                                             ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	JB .skip_SWP                                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	align 16
	.yA16_loop:
	MOVDQU [r8], xmm0                                                      ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVDQU xmm0, [rcx]                                                     ; r8, r9, rcx, rdx, rsp, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	PMULLD xmm4, [byte rdx + 64]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVDQU [byte r8 + 16], xmm1                                            ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVDQU xmm1, [byte rcx + 16]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	PMULLD xmm5, [byte rdx + 80]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVDQU [byte r8 + 32], xmm2                                            ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVDQU xmm2, [byte rcx + 32]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm3, xmm4, xmm5, xmm6, xmm7
	PMULLD xmm6, [byte rdx + 96]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVDQU [byte r8 + 48], xmm3                                            ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVDQU xmm3, [byte rcx + 48]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm4, xmm5, xmm6, xmm7
	PMULLD xmm7, [byte rdx + 112]                                          ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	SUB rdx, -128                                                          ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVDQU [byte r8 + 64], xmm4                                            ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVDQU xmm4, [byte rcx + 64]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm5, xmm6, xmm7
	PMULLD xmm0, [rdx]                                                     ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVDQU [byte r8 + 80], xmm5                                            ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVDQU xmm5, [byte rcx + 80]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm6, xmm7
	PMULLD xmm1, [byte rdx + 16]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVDQU [byte r8 + 96], xmm6                                            ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVDQU xmm6, [byte rcx + 96]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm7
	PMULLD xmm2, [byte rdx + 32]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVDQU [byte r8 + 112], xmm7                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVDQU xmm7, [byte rcx + 112]                                          ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	PMULLD xmm3, [byte rdx + 48]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	SUB rcx, -128                                                          ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	SUB r8, -128                                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	SUB r9, 32                                                             ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	JAE .yA16_loop                                                         ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	.skip_SWP:
	MOVDQU [r8], xmm0                                                      ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	PMULLD xmm4, [byte rdx + 64]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVDQU [byte r8 + 16], xmm1                                            ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	PMULLD xmm5, [byte rdx + 80]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVDQU [byte r8 + 32], xmm2                                            ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	PMULLD xmm6, [byte rdx + 96]                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVDQU [byte r8 + 48], xmm3                                            ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	PMULLD xmm7, [byte rdx + 112]                                          ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	SUB rdx, -128                                                          ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVDQU [byte r8 + 64], xmm4                                            ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	PMULLD xmm0, [rdx]                                                     ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm5, xmm6, xmm7
	MOVDQU [byte r8 + 80], xmm5                                            ; r8, r9, rcx, rdx, rsp, xmm1, xmm2, xmm3, xmm5, xmm6, xmm7
	PMULLD xmm1, [byte rdx + 16]                                           ; r8, r9, rcx, rdx, rsp, xmm1, xmm2, xmm3, xmm6, xmm7
	MOVDQU [byte r8 + 96], xmm6                                            ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm6, xmm7
	PMULLD xmm2, [byte rdx + 32]                                           ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm7
	MOVDQU [byte r8 + 112], xmm7                                           ; r8, r9, rcx, rdx, rsp, xmm3, xmm7
	PMULLD xmm3, [byte rdx + 48]                                           ; r8, r9, rcx, rdx, rsp, xmm3
	SUB r8, -128                                                           ; r8, r9, rcx, rdx, rsp
	.yA16_restore:
	ADD r9, 32                                                             ; r8, r9, rcx, rdx, rsp
	JZ .return_ok                                                          ; r8, r9, rcx, rdx, rsp
	.finalize:
	MOV eax, [rcx]                                                         ; r8, r9, rcx, rdx, rsp
	IMUL eax, [rdx]                                                        ; eax, r8, r9, rcx, rdx, rsp
	MOV [r8], eax                                                          ; eax, r8, r9, rcx, rdx, rsp
	ADD rcx, 4                                                             ; r8, r9, rcx, rdx, rsp
	ADD rdx, 4                                                             ; r8, r9, rdx, rsp
	ADD r8, 4                                                              ; r8, r9, rsp
	SUB r9, 1                                                              ; r9, rsp
	JNZ .finalize                                                          ; rsp
	.return_ok:
	XOR eax, eax                                                           ; rsp
	.return:
	MOVAPS xmm7, [rsp]                                                     ; 
	MOVAPS xmm6, [byte rsp + 16]                                           ; 
	ADD rsp, 40                                                            ; 
	RET                                                                    ; rsp

section .text$4 code align=16
global _yepCore_Multiply_V32uV32u_V64u_Nehalem
_yepCore_Multiply_V32uV32u_V64u_Nehalem:
	.ENTRY:
	PUSH rbx                                                               ; 
	SUB rsp, 96                                                            ; 
	MOVAPS [rsp], xmm6                                                     ; 
	MOVAPS [byte rsp + 16], xmm7                                           ; 
	MOVAPS [byte rsp + 32], xmm8                                           ; 
	MOVAPS [byte rsp + 48], xmm9                                           ; 
	MOVAPS [byte rsp + 64], xmm10                                          ; 
	MOVAPS [byte rsp + 80], xmm11                                          ; 
	.zM16:
	TEST r8, 15                                                            ; 
	JZ .zA16                                                               ; 
	MOV eax, [rcx]                                                         ; 
	MOV ebx, [rdx]                                                         ; 
	IMUL rax, rbx                                                          ; 
	MOV [r8], rax                                                          ; 
	ADD rcx, 4                                                             ; 
	ADD rdx, 4                                                             ; 
	ADD r8, 8                                                              ; 
	SUB r9, 1                                                              ; 
	JZ .return_ok                                                          ; 
	JMP .zM16                                                              ; 
	.zA16:
	SUB r9, 12                                                             ; r8, r9, rcx, rdx, rsp
	JB .zA16_restore                                                       ; r8, r9, rcx, rdx, rsp
	PMOVZXDQ xmm0, [rcx]                                                   ; r8, r9, rcx, rdx, rsp
	PMOVZXDQ xmm1, [rdx]                                                   ; r8, r9, rcx, rdx, rsp, xmm0
	PMOVZXDQ xmm2, [byte rcx + 8]                                          ; r8, r9, rcx, rdx, rsp, xmm0, xmm1
	PMOVZXDQ xmm3, [byte rdx + 8]                                          ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2
	PMOVZXDQ xmm4, [byte rcx + 16]                                         ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3
	PMOVZXDQ xmm5, [byte rdx + 16]                                         ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	PMOVZXDQ xmm6, [byte rcx + 24]                                         ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	PMOVZXDQ xmm7, [byte rdx + 24]                                         ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	PMULUDQ xmm0, xmm1                                                     ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	PMOVZXDQ xmm8, [byte rcx + 32]                                         ; r8, r9, rcx, rdx, rsp, xmm0, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	PMOVZXDQ xmm9, [byte rdx + 32]                                         ; r8, r9, rcx, rdx, rsp, xmm0, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8
	PMULUDQ xmm2, xmm3                                                     ; r8, r9, rcx, rdx, rsp, xmm0, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	PMOVZXDQ xmm10, [byte rcx + 40]                                        ; r8, r9, rcx, rdx, rsp, xmm0, xmm2, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	PMOVZXDQ xmm11, [byte rdx + 40]                                        ; r8, r9, rcx, rdx, rsp, xmm0, xmm10, xmm2, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	PMULUDQ xmm4, xmm5                                                     ; r8, r9, rcx, rdx, rsp, xmm0, xmm10, xmm11, xmm2, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADD rcx, 48                                                            ; r8, r9, rcx, rdx, rsp, xmm0, xmm10, xmm11, xmm2, xmm4, xmm6, xmm7, xmm8, xmm9
	ADD rdx, 48                                                            ; r8, r9, rcx, rdx, rsp, xmm0, xmm10, xmm11, xmm2, xmm4, xmm6, xmm7, xmm8, xmm9
	SUB r9, 12                                                             ; r8, r9, rcx, rdx, rsp, xmm0, xmm10, xmm11, xmm2, xmm4, xmm6, xmm7, xmm8, xmm9
	JB .skip_SWP                                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm10, xmm11, xmm2, xmm4, xmm6, xmm7, xmm8, xmm9
	align 16
	.zA16_loop:
	MOVDQA [r8], xmm0                                                      ; r8, r9, rcx, rdx, rsp, xmm0, xmm10, xmm11, xmm2, xmm4, xmm6, xmm7, xmm8, xmm9
	PMOVZXDQ xmm0, [rcx]                                                   ; r8, r9, rcx, rdx, rsp, xmm10, xmm11, xmm2, xmm4, xmm6, xmm7, xmm8, xmm9
	PMOVZXDQ xmm1, [rdx]                                                   ; r8, r9, rcx, rdx, rsp, xmm0, xmm10, xmm11, xmm2, xmm4, xmm6, xmm7, xmm8, xmm9
	PMULUDQ xmm6, xmm7                                                     ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm10, xmm11, xmm2, xmm4, xmm6, xmm7, xmm8, xmm9
	MOVDQA [byte r8 + 16], xmm2                                            ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm10, xmm11, xmm2, xmm4, xmm6, xmm8, xmm9
	PMOVZXDQ xmm2, [byte rcx + 8]                                          ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm10, xmm11, xmm4, xmm6, xmm8, xmm9
	PMOVZXDQ xmm3, [byte rdx + 8]                                          ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm10, xmm11, xmm2, xmm4, xmm6, xmm8, xmm9
	PMULUDQ xmm8, xmm9                                                     ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm10, xmm11, xmm2, xmm3, xmm4, xmm6, xmm8, xmm9
	MOVDQA [byte r8 + 32], xmm4                                            ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm10, xmm11, xmm2, xmm3, xmm4, xmm6, xmm8
	PMOVZXDQ xmm4, [byte rcx + 16]                                         ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm10, xmm11, xmm2, xmm3, xmm6, xmm8
	PMOVZXDQ xmm5, [byte rdx + 16]                                         ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm10, xmm11, xmm2, xmm3, xmm4, xmm6, xmm8
	PMULUDQ xmm10, xmm11                                                   ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm10, xmm11, xmm2, xmm3, xmm4, xmm5, xmm6, xmm8
	MOVDQA [byte r8 + 48], xmm6                                            ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm10, xmm2, xmm3, xmm4, xmm5, xmm6, xmm8
	PMOVZXDQ xmm6, [byte rcx + 24]                                         ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm10, xmm2, xmm3, xmm4, xmm5, xmm8
	PMOVZXDQ xmm7, [byte rdx + 24]                                         ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm10, xmm2, xmm3, xmm4, xmm5, xmm6, xmm8
	PMULUDQ xmm0, xmm1                                                     ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm10, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8
	MOVDQA [byte r8 + 64], xmm8                                            ; r8, r9, rcx, rdx, rsp, xmm0, xmm10, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8
	PMOVZXDQ xmm8, [byte rcx + 32]                                         ; r8, r9, rcx, rdx, rsp, xmm0, xmm10, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	PMOVZXDQ xmm9, [byte rdx + 32]                                         ; r8, r9, rcx, rdx, rsp, xmm0, xmm10, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8
	PMULUDQ xmm2, xmm3                                                     ; r8, r9, rcx, rdx, rsp, xmm0, xmm10, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVDQA [byte r8 + 80], xmm10                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm10, xmm2, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	PMOVZXDQ xmm10, [byte rcx + 40]                                        ; r8, r9, rcx, rdx, rsp, xmm0, xmm2, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	PMOVZXDQ xmm11, [byte rdx + 40]                                        ; r8, r9, rcx, rdx, rsp, xmm0, xmm10, xmm2, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	PMULUDQ xmm4, xmm5                                                     ; r8, r9, rcx, rdx, rsp, xmm0, xmm10, xmm11, xmm2, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADD rcx, 48                                                            ; r8, r9, rcx, rdx, rsp, xmm0, xmm10, xmm11, xmm2, xmm4, xmm6, xmm7, xmm8, xmm9
	ADD rdx, 48                                                            ; r8, r9, rcx, rdx, rsp, xmm0, xmm10, xmm11, xmm2, xmm4, xmm6, xmm7, xmm8, xmm9
	ADD r8, 96                                                             ; r8, r9, rcx, rdx, rsp, xmm0, xmm10, xmm11, xmm2, xmm4, xmm6, xmm7, xmm8, xmm9
	SUB r9, 12                                                             ; r8, r9, rcx, rdx, rsp, xmm0, xmm10, xmm11, xmm2, xmm4, xmm6, xmm7, xmm8, xmm9
	JAE .zA16_loop                                                         ; r8, r9, rcx, rdx, rsp, xmm0, xmm10, xmm11, xmm2, xmm4, xmm6, xmm7, xmm8, xmm9
	.skip_SWP:
	MOVDQA [r8], xmm0                                                      ; r8, r9, rcx, rdx, rsp, xmm0, xmm10, xmm11, xmm2, xmm4, xmm6, xmm7, xmm8, xmm9
	PMULUDQ xmm6, xmm7                                                     ; r8, r9, rcx, rdx, rsp, xmm10, xmm11, xmm2, xmm4, xmm6, xmm7, xmm8, xmm9
	MOVDQA [byte r8 + 16], xmm2                                            ; r8, r9, rcx, rdx, rsp, xmm10, xmm11, xmm2, xmm4, xmm6, xmm8, xmm9
	PMULUDQ xmm8, xmm9                                                     ; r8, r9, rcx, rdx, rsp, xmm10, xmm11, xmm4, xmm6, xmm8, xmm9
	MOVDQA [byte r8 + 32], xmm4                                            ; r8, r9, rcx, rdx, rsp, xmm10, xmm11, xmm4, xmm6, xmm8
	PMULUDQ xmm10, xmm11                                                   ; r8, r9, rcx, rdx, rsp, xmm10, xmm11, xmm6, xmm8
	MOVDQA [byte r8 + 48], xmm6                                            ; r8, r9, rcx, rdx, rsp, xmm10, xmm6, xmm8
	MOVDQA [byte r8 + 64], xmm8                                            ; r8, r9, rcx, rdx, rsp, xmm10, xmm8
	MOVDQA [byte r8 + 80], xmm10                                           ; r8, r9, rcx, rdx, rsp, xmm10
	ADD r8, 96                                                             ; r8, r9, rcx, rdx, rsp
	.zA16_restore:
	ADD r9, 12                                                             ; r8, r9, rcx, rdx, rsp
	JZ .return_ok                                                          ; r8, r9, rcx, rdx, rsp
	.finalize:
	MOV eax, [rcx]                                                         ; r8, r9, rcx, rdx, rsp
	MOV ebx, [rdx]                                                         ; r8, r9, rax, rcx, rdx, rsp
	IMUL rax, rbx                                                          ; r8, r9, rax, rbx, rcx, rdx, rsp
	MOV [r8], rax                                                          ; r8, r9, rax, rcx, rdx, rsp
	ADD rcx, 4                                                             ; r8, r9, rcx, rdx, rsp
	ADD rdx, 4                                                             ; r8, r9, rdx, rsp
	ADD r8, 8                                                              ; r8, r9, rsp
	SUB r9, 1                                                              ; r9, rsp
	JNZ .finalize                                                          ; rsp
	.return_ok:
	XOR eax, eax                                                           ; rsp
	.return:
	MOVAPS xmm11, [rsp]                                                    ; 
	MOVAPS xmm10, [byte rsp + 16]                                          ; 
	MOVAPS xmm9, [byte rsp + 32]                                           ; 
	MOVAPS xmm8, [byte rsp + 48]                                           ; 
	MOVAPS xmm7, [byte rsp + 64]                                           ; 
	MOVAPS xmm6, [byte rsp + 80]                                           ; 
	ADD rsp, 96                                                            ; 
	POP rbx                                                                ; 
	RET                                                                    ; rsp

section .text$4 code align=16
global _yepCore_Multiply_V32sV32s_V64s_Nehalem
_yepCore_Multiply_V32sV32s_V64s_Nehalem:
	.ENTRY:
	PUSH rbx                                                               ; 
	SUB rsp, 96                                                            ; 
	MOVAPS [rsp], xmm6                                                     ; 
	MOVAPS [byte rsp + 16], xmm7                                           ; 
	MOVAPS [byte rsp + 32], xmm8                                           ; 
	MOVAPS [byte rsp + 48], xmm9                                           ; 
	MOVAPS [byte rsp + 64], xmm10                                          ; 
	MOVAPS [byte rsp + 80], xmm11                                          ; 
	.zM16:
	TEST r8, 15                                                            ; 
	JZ .zA16                                                               ; 
	MOVSX rax, dword [rcx]                                                 ; 
	MOVSX rbx, dword [rdx]                                                 ; 
	IMUL rax, rbx                                                          ; 
	MOV [r8], rax                                                          ; 
	ADD rcx, 4                                                             ; 
	ADD rdx, 4                                                             ; 
	ADD r8, 8                                                              ; 
	SUB r9, 1                                                              ; 
	JZ .return_ok                                                          ; 
	JMP .zM16                                                              ; 
	.zA16:
	SUB r9, 12                                                             ; r8, r9, rcx, rdx, rsp
	JB .zA16_restore                                                       ; r8, r9, rcx, rdx, rsp
	PMOVZXDQ xmm0, [rcx]                                                   ; r8, r9, rcx, rdx, rsp
	PMOVZXDQ xmm1, [rdx]                                                   ; r8, r9, rcx, rdx, rsp, xmm0
	PMOVZXDQ xmm2, [byte rcx + 8]                                          ; r8, r9, rcx, rdx, rsp, xmm0, xmm1
	PMOVZXDQ xmm3, [byte rdx + 8]                                          ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2
	PMOVZXDQ xmm4, [byte rcx + 16]                                         ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3
	PMOVZXDQ xmm5, [byte rdx + 16]                                         ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	PMOVZXDQ xmm6, [byte rcx + 24]                                         ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	PMOVZXDQ xmm7, [byte rdx + 24]                                         ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	PMULDQ xmm0, xmm1                                                      ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	PMOVZXDQ xmm8, [byte rcx + 32]                                         ; r8, r9, rcx, rdx, rsp, xmm0, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	PMOVZXDQ xmm9, [byte rdx + 32]                                         ; r8, r9, rcx, rdx, rsp, xmm0, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8
	PMULDQ xmm2, xmm3                                                      ; r8, r9, rcx, rdx, rsp, xmm0, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	PMOVZXDQ xmm10, [byte rcx + 40]                                        ; r8, r9, rcx, rdx, rsp, xmm0, xmm2, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	PMOVZXDQ xmm11, [byte rdx + 40]                                        ; r8, r9, rcx, rdx, rsp, xmm0, xmm10, xmm2, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	PMULDQ xmm4, xmm5                                                      ; r8, r9, rcx, rdx, rsp, xmm0, xmm10, xmm11, xmm2, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADD rcx, 48                                                            ; r8, r9, rcx, rdx, rsp, xmm0, xmm10, xmm11, xmm2, xmm4, xmm6, xmm7, xmm8, xmm9
	ADD rdx, 48                                                            ; r8, r9, rcx, rdx, rsp, xmm0, xmm10, xmm11, xmm2, xmm4, xmm6, xmm7, xmm8, xmm9
	SUB r9, 12                                                             ; r8, r9, rcx, rdx, rsp, xmm0, xmm10, xmm11, xmm2, xmm4, xmm6, xmm7, xmm8, xmm9
	JB .skip_SWP                                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm10, xmm11, xmm2, xmm4, xmm6, xmm7, xmm8, xmm9
	align 16
	.zA16_loop:
	MOVDQA [r8], xmm0                                                      ; r8, r9, rcx, rdx, rsp, xmm0, xmm10, xmm11, xmm2, xmm4, xmm6, xmm7, xmm8, xmm9
	PMOVZXDQ xmm0, [rcx]                                                   ; r8, r9, rcx, rdx, rsp, xmm10, xmm11, xmm2, xmm4, xmm6, xmm7, xmm8, xmm9
	PMOVZXDQ xmm1, [rdx]                                                   ; r8, r9, rcx, rdx, rsp, xmm0, xmm10, xmm11, xmm2, xmm4, xmm6, xmm7, xmm8, xmm9
	PMULDQ xmm6, xmm7                                                      ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm10, xmm11, xmm2, xmm4, xmm6, xmm7, xmm8, xmm9
	MOVDQA [byte r8 + 16], xmm2                                            ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm10, xmm11, xmm2, xmm4, xmm6, xmm8, xmm9
	PMOVZXDQ xmm2, [byte rcx + 8]                                          ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm10, xmm11, xmm4, xmm6, xmm8, xmm9
	PMOVZXDQ xmm3, [byte rdx + 8]                                          ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm10, xmm11, xmm2, xmm4, xmm6, xmm8, xmm9
	PMULDQ xmm8, xmm9                                                      ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm10, xmm11, xmm2, xmm3, xmm4, xmm6, xmm8, xmm9
	MOVDQA [byte r8 + 32], xmm4                                            ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm10, xmm11, xmm2, xmm3, xmm4, xmm6, xmm8
	PMOVZXDQ xmm4, [byte rcx + 16]                                         ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm10, xmm11, xmm2, xmm3, xmm6, xmm8
	PMOVZXDQ xmm5, [byte rdx + 16]                                         ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm10, xmm11, xmm2, xmm3, xmm4, xmm6, xmm8
	PMULDQ xmm10, xmm11                                                    ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm10, xmm11, xmm2, xmm3, xmm4, xmm5, xmm6, xmm8
	MOVDQA [byte r8 + 48], xmm6                                            ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm10, xmm2, xmm3, xmm4, xmm5, xmm6, xmm8
	PMOVZXDQ xmm6, [byte rcx + 24]                                         ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm10, xmm2, xmm3, xmm4, xmm5, xmm8
	PMOVZXDQ xmm7, [byte rdx + 24]                                         ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm10, xmm2, xmm3, xmm4, xmm5, xmm6, xmm8
	PMULDQ xmm0, xmm1                                                      ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm10, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8
	MOVDQA [byte r8 + 64], xmm8                                            ; r8, r9, rcx, rdx, rsp, xmm0, xmm10, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8
	PMOVZXDQ xmm8, [byte rcx + 32]                                         ; r8, r9, rcx, rdx, rsp, xmm0, xmm10, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	PMOVZXDQ xmm9, [byte rdx + 32]                                         ; r8, r9, rcx, rdx, rsp, xmm0, xmm10, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8
	PMULDQ xmm2, xmm3                                                      ; r8, r9, rcx, rdx, rsp, xmm0, xmm10, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVDQA [byte r8 + 80], xmm10                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm10, xmm2, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	PMOVZXDQ xmm10, [byte rcx + 40]                                        ; r8, r9, rcx, rdx, rsp, xmm0, xmm2, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	PMOVZXDQ xmm11, [byte rdx + 40]                                        ; r8, r9, rcx, rdx, rsp, xmm0, xmm10, xmm2, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	PMULDQ xmm4, xmm5                                                      ; r8, r9, rcx, rdx, rsp, xmm0, xmm10, xmm11, xmm2, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADD rcx, 48                                                            ; r8, r9, rcx, rdx, rsp, xmm0, xmm10, xmm11, xmm2, xmm4, xmm6, xmm7, xmm8, xmm9
	ADD rdx, 48                                                            ; r8, r9, rcx, rdx, rsp, xmm0, xmm10, xmm11, xmm2, xmm4, xmm6, xmm7, xmm8, xmm9
	ADD r8, 96                                                             ; r8, r9, rcx, rdx, rsp, xmm0, xmm10, xmm11, xmm2, xmm4, xmm6, xmm7, xmm8, xmm9
	SUB r9, 12                                                             ; r8, r9, rcx, rdx, rsp, xmm0, xmm10, xmm11, xmm2, xmm4, xmm6, xmm7, xmm8, xmm9
	JAE .zA16_loop                                                         ; r8, r9, rcx, rdx, rsp, xmm0, xmm10, xmm11, xmm2, xmm4, xmm6, xmm7, xmm8, xmm9
	.skip_SWP:
	MOVDQA [r8], xmm0                                                      ; r8, r9, rcx, rdx, rsp, xmm0, xmm10, xmm11, xmm2, xmm4, xmm6, xmm7, xmm8, xmm9
	PMULDQ xmm6, xmm7                                                      ; r8, r9, rcx, rdx, rsp, xmm10, xmm11, xmm2, xmm4, xmm6, xmm7, xmm8, xmm9
	MOVDQA [byte r8 + 16], xmm2                                            ; r8, r9, rcx, rdx, rsp, xmm10, xmm11, xmm2, xmm4, xmm6, xmm8, xmm9
	PMULDQ xmm8, xmm9                                                      ; r8, r9, rcx, rdx, rsp, xmm10, xmm11, xmm4, xmm6, xmm8, xmm9
	MOVDQA [byte r8 + 32], xmm4                                            ; r8, r9, rcx, rdx, rsp, xmm10, xmm11, xmm4, xmm6, xmm8
	PMULDQ xmm10, xmm11                                                    ; r8, r9, rcx, rdx, rsp, xmm10, xmm11, xmm6, xmm8
	MOVDQA [byte r8 + 48], xmm6                                            ; r8, r9, rcx, rdx, rsp, xmm10, xmm6, xmm8
	MOVDQA [byte r8 + 64], xmm8                                            ; r8, r9, rcx, rdx, rsp, xmm10, xmm8
	MOVDQA [byte r8 + 80], xmm10                                           ; r8, r9, rcx, rdx, rsp, xmm10
	ADD r8, 96                                                             ; r8, r9, rcx, rdx, rsp
	.zA16_restore:
	ADD r9, 12                                                             ; r8, r9, rcx, rdx, rsp
	JZ .return_ok                                                          ; r8, r9, rcx, rdx, rsp
	.finalize:
	MOVSX rax, dword [rcx]                                                 ; r8, r9, rcx, rdx, rsp
	MOVSX rbx, dword [rdx]                                                 ; r8, r9, rax, rcx, rdx, rsp
	IMUL rax, rbx                                                          ; r8, r9, rax, rbx, rcx, rdx, rsp
	MOV [r8], rax                                                          ; r8, r9, rax, rcx, rdx, rsp
	ADD rcx, 4                                                             ; r8, r9, rcx, rdx, rsp
	ADD rdx, 4                                                             ; r8, r9, rdx, rsp
	ADD r8, 8                                                              ; r8, r9, rsp
	SUB r9, 1                                                              ; r9, rsp
	JNZ .finalize                                                          ; rsp
	.return_ok:
	XOR eax, eax                                                           ; rsp
	.return:
	MOVAPS xmm11, [rsp]                                                    ; 
	MOVAPS xmm10, [byte rsp + 16]                                          ; 
	MOVAPS xmm9, [byte rsp + 32]                                           ; 
	MOVAPS xmm8, [byte rsp + 48]                                           ; 
	MOVAPS xmm7, [byte rsp + 64]                                           ; 
	MOVAPS xmm6, [byte rsp + 80]                                           ; 
	ADD rsp, 96                                                            ; 
	POP rbx                                                                ; 
	RET                                                                    ; rsp

section .text$4 code align=16
global _yepCore_Multiply_V32fV32f_V32f_Nehalem
_yepCore_Multiply_V32fV32f_V32f_Nehalem:
	.ENTRY:
	SUB rsp, 40                                                            ; 
	MOVAPS [rsp], xmm6                                                     ; 
	MOVAPS [byte rsp + 16], xmm7                                           ; 
	MOV r11, rcx                                                           ; 
	MOV rax, rdx                                                           ; 
	MOV r9, r8                                                             ; 
	MOV r10, r9                                                            ; 
	.yM16:
	TEST rax, 15                                                           ; 
	JZ .yA16                                                               ; 
	MOVSS xmm0, [r11]                                                      ; 
	MOVSS xmm1, [rax]                                                      ; 
	MULSS xmm0, xmm1                                                       ; 
	MOVSS [r9], xmm0                                                       ; 
	ADD r11, 4                                                             ; 
	ADD rax, 4                                                             ; 
	ADD r9, 4                                                              ; 
	SUB r10, 1                                                             ; 
	JZ .return_ok                                                          ; 
	JMP .yM16                                                              ; 
	.yA16:
	SUB r10, 32                                                            ; r10, r11, r9, rax, rsp
	JB .yA16_restore                                                       ; r10, r11, r9, rax, rsp
	MOVUPS xmm0, [r11]                                                     ; r10, r11, r9, rax, rsp
	MOVUPS xmm1, [byte r11 + 16]                                           ; r10, r11, r9, rax, rsp, xmm0
	MOVUPS xmm2, [byte r11 + 32]                                           ; r10, r11, r9, rax, rsp, xmm0, xmm1
	MULPS xmm0, [rax]                                                      ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2
	MOVUPS xmm3, [byte r11 + 48]                                           ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2
	MULPS xmm1, [byte rax + 16]                                            ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3
	MOVUPS xmm4, [byte r11 + 64]                                           ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3
	MULPS xmm2, [byte rax + 32]                                            ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	MOVUPS xmm5, [byte r11 + 80]                                           ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	MULPS xmm3, [byte rax + 48]                                            ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	MOVUPS xmm6, [byte r11 + 96]                                           ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	MULPS xmm4, [byte rax + 64]                                            ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	MOVUPS xmm7, [byte r11 + 112]                                          ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	MULPS xmm5, [byte rax + 80]                                            ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	ADD r11, 128                                                           ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	SUB r10, 32                                                            ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	JB .skip_SWP                                                           ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	align 16
	.yA16_loop:
	MOVUPS [r9], xmm0                                                      ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVUPS xmm0, [r11]                                                     ; r10, r11, r9, rax, rsp, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MULPS xmm6, [byte rax + 96]                                            ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVUPS [byte r9 + 16], xmm1                                            ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVUPS xmm1, [byte r11 + 16]                                           ; r10, r11, r9, rax, rsp, xmm0, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MULPS xmm7, [byte rax + 112]                                           ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	ADD rax, 128                                                           ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVUPS [byte r9 + 32], xmm2                                            ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVUPS xmm2, [byte r11 + 32]                                           ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm3, xmm4, xmm5, xmm6, xmm7
	MULPS xmm0, [rax]                                                      ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVUPS [byte r9 + 48], xmm3                                            ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVUPS xmm3, [byte r11 + 48]                                           ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm4, xmm5, xmm6, xmm7
	MULPS xmm1, [byte rax + 16]                                            ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVUPS [byte r9 + 64], xmm4                                            ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVUPS xmm4, [byte r11 + 64]                                           ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm5, xmm6, xmm7
	MULPS xmm2, [byte rax + 32]                                            ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVUPS [byte r9 + 80], xmm5                                            ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVUPS xmm5, [byte r11 + 80]                                           ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm6, xmm7
	MULPS xmm3, [byte rax + 48]                                            ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVUPS [byte r9 + 96], xmm6                                            ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVUPS xmm6, [byte r11 + 96]                                           ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm7
	MULPS xmm4, [byte rax + 64]                                            ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVUPS [byte r9 + 112], xmm7                                           ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVUPS xmm7, [byte r11 + 112]                                          ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	MULPS xmm5, [byte rax + 80]                                            ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	ADD r11, 128                                                           ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	ADD r9, 128                                                            ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	SUB r10, 32                                                            ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	JAE .yA16_loop                                                         ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	.skip_SWP:
	MOVUPS [r9], xmm0                                                      ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MULPS xmm6, [byte rax + 96]                                            ; r10, r11, r9, rax, rsp, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVUPS [byte r9 + 16], xmm1                                            ; r10, r11, r9, rax, rsp, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MULPS xmm7, [byte rax + 112]                                           ; r10, r11, r9, rax, rsp, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVUPS [byte r9 + 32], xmm2                                            ; r10, r11, r9, rax, rsp, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVUPS [byte r9 + 48], xmm3                                            ; r10, r11, r9, rax, rsp, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVUPS [byte r9 + 64], xmm4                                            ; r10, r11, r9, rax, rsp, xmm4, xmm5, xmm6, xmm7
	MOVUPS [byte r9 + 80], xmm5                                            ; r10, r11, r9, rax, rsp, xmm5, xmm6, xmm7
	MOVUPS [byte r9 + 96], xmm6                                            ; r10, r11, r9, rax, rsp, xmm6, xmm7
	MOVUPS [byte r9 + 112], xmm7                                           ; r10, r11, r9, rax, rsp, xmm7
	ADD rax, 128                                                           ; r10, r11, r9, rax, rsp
	ADD r9, 128                                                            ; r10, r11, r9, rax, rsp
	.yA16_restore:
	ADD r10, 32                                                            ; r10, r11, r9, rax, rsp
	JZ .return_ok                                                          ; r10, r11, r9, rax, rsp
	.finalize:
	MOVSS xmm0, [r11]                                                      ; r10, r11, r9, rax, rsp
	MOVSS xmm1, [rax]                                                      ; r10, r11, r9, rax, rsp, xmm0
	MULSS xmm0, xmm1                                                       ; r10, r11, r9, rax, rsp, xmm0, xmm1
	MOVSS [r9], xmm0                                                       ; r10, r11, r9, rax, rsp, xmm0
	ADD r11, 4                                                             ; r10, r11, r9, rax, rsp
	ADD rax, 4                                                             ; r10, r9, rax, rsp
	ADD r9, 4                                                              ; r10, r9, rsp
	SUB r10, 1                                                             ; r10, rsp
	JNZ .finalize                                                          ; rsp
	.return_ok:
	XOR eax, eax                                                           ; rsp
	.return:
	MOVAPS xmm7, [rsp]                                                     ; 
	MOVAPS xmm6, [byte rsp + 16]                                           ; 
	ADD rsp, 40                                                            ; 
	RET                                                                    ; rsp

section .text$4 code align=16
global _yepCore_Multiply_V64fV64f_V64f_Nehalem
_yepCore_Multiply_V64fV64f_V64f_Nehalem:
	.ENTRY:
	SUB rsp, 40                                                            ; 
	MOVAPS [rsp], xmm6                                                     ; 
	MOVAPS [byte rsp + 16], xmm7                                           ; 
	MOV r11, rcx                                                           ; 
	MOV rax, rdx                                                           ; 
	MOV r9, r8                                                             ; 
	MOV r10, r9                                                            ; 
	.yM16:
	TEST rax, 15                                                           ; 
	JZ .yA16                                                               ; 
	MOVSD xmm0, [r11]                                                      ; 
	MOVSD xmm1, [rax]                                                      ; 
	MULSD xmm0, xmm1                                                       ; 
	MOVSD [r9], xmm0                                                       ; 
	ADD r11, 8                                                             ; 
	ADD rax, 8                                                             ; 
	ADD r9, 8                                                              ; 
	SUB r10, 1                                                             ; 
	JZ .return_ok                                                          ; 
	JMP .yM16                                                              ; 
	.yA16:
	SUB r10, 16                                                            ; r10, r11, r9, rax, rsp
	JB .yA16_restore                                                       ; r10, r11, r9, rax, rsp
	MOVUPD xmm0, [r11]                                                     ; r10, r11, r9, rax, rsp
	MOVUPD xmm1, [byte r11 + 16]                                           ; r10, r11, r9, rax, rsp, xmm0
	MOVUPD xmm2, [byte r11 + 32]                                           ; r10, r11, r9, rax, rsp, xmm0, xmm1
	MULPD xmm0, [rax]                                                      ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2
	MOVUPD xmm3, [byte r11 + 48]                                           ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2
	MULPD xmm1, [byte rax + 16]                                            ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3
	MOVUPD xmm4, [byte r11 + 64]                                           ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3
	MULPD xmm2, [byte rax + 32]                                            ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	MOVUPD xmm5, [byte r11 + 80]                                           ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	MULPD xmm3, [byte rax + 48]                                            ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	MOVUPD xmm6, [byte r11 + 96]                                           ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	MULPD xmm4, [byte rax + 64]                                            ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	MOVUPD xmm7, [byte r11 + 112]                                          ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	MULPD xmm5, [byte rax + 80]                                            ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	ADD r11, 128                                                           ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	SUB r10, 16                                                            ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	JB .skip_SWP                                                           ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	align 16
	.yA16_loop:
	MOVUPD [r9], xmm0                                                      ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVUPD xmm0, [r11]                                                     ; r10, r11, r9, rax, rsp, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MULPD xmm6, [byte rax + 96]                                            ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVUPD [byte r9 + 16], xmm1                                            ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVUPD xmm1, [byte r11 + 16]                                           ; r10, r11, r9, rax, rsp, xmm0, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MULPD xmm7, [byte rax + 112]                                           ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	ADD rax, 128                                                           ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVUPD [byte r9 + 32], xmm2                                            ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVUPD xmm2, [byte r11 + 32]                                           ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm3, xmm4, xmm5, xmm6, xmm7
	MULPD xmm0, [rax]                                                      ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVUPD [byte r9 + 48], xmm3                                            ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVUPD xmm3, [byte r11 + 48]                                           ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm4, xmm5, xmm6, xmm7
	MULPD xmm1, [byte rax + 16]                                            ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVUPD [byte r9 + 64], xmm4                                            ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVUPD xmm4, [byte r11 + 64]                                           ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm5, xmm6, xmm7
	MULPD xmm2, [byte rax + 32]                                            ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVUPD [byte r9 + 80], xmm5                                            ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVUPD xmm5, [byte r11 + 80]                                           ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm6, xmm7
	MULPD xmm3, [byte rax + 48]                                            ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVUPD [byte r9 + 96], xmm6                                            ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVUPD xmm6, [byte r11 + 96]                                           ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm7
	MULPD xmm4, [byte rax + 64]                                            ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVUPD [byte r9 + 112], xmm7                                           ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVUPD xmm7, [byte r11 + 112]                                          ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	MULPD xmm5, [byte rax + 80]                                            ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	ADD r11, 128                                                           ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	ADD r9, 128                                                            ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	SUB r10, 16                                                            ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	JAE .yA16_loop                                                         ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	.skip_SWP:
	MOVUPD [r9], xmm0                                                      ; r10, r11, r9, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MULPD xmm6, [byte rax + 96]                                            ; r10, r11, r9, rax, rsp, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVUPD [byte r9 + 16], xmm1                                            ; r10, r11, r9, rax, rsp, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MULPD xmm7, [byte rax + 112]                                           ; r10, r11, r9, rax, rsp, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVUPD [byte r9 + 32], xmm2                                            ; r10, r11, r9, rax, rsp, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVUPD [byte r9 + 48], xmm3                                            ; r10, r11, r9, rax, rsp, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVUPD [byte r9 + 64], xmm4                                            ; r10, r11, r9, rax, rsp, xmm4, xmm5, xmm6, xmm7
	MOVUPD [byte r9 + 80], xmm5                                            ; r10, r11, r9, rax, rsp, xmm5, xmm6, xmm7
	MOVUPD [byte r9 + 96], xmm6                                            ; r10, r11, r9, rax, rsp, xmm6, xmm7
	MOVUPD [byte r9 + 112], xmm7                                           ; r10, r11, r9, rax, rsp, xmm7
	ADD rax, 128                                                           ; r10, r11, r9, rax, rsp
	ADD r9, 128                                                            ; r10, r11, r9, rax, rsp
	.yA16_restore:
	ADD r10, 16                                                            ; r10, r11, r9, rax, rsp
	JZ .return_ok                                                          ; r10, r11, r9, rax, rsp
	.finalize:
	MOVSD xmm0, [r11]                                                      ; r10, r11, r9, rax, rsp
	MOVSD xmm1, [rax]                                                      ; r10, r11, r9, rax, rsp, xmm0
	MULSD xmm0, xmm1                                                       ; r10, r11, r9, rax, rsp, xmm0, xmm1
	MOVSD [r9], xmm0                                                       ; r10, r11, r9, rax, rsp, xmm0
	ADD r11, 8                                                             ; r10, r11, r9, rax, rsp
	ADD rax, 8                                                             ; r10, r9, rax, rsp
	ADD r9, 8                                                              ; r10, r9, rsp
	SUB r10, 1                                                             ; r10, rsp
	JNZ .finalize                                                          ; rsp
	.return_ok:
	XOR eax, eax                                                           ; rsp
	.return:
	MOVAPS xmm7, [rsp]                                                     ; 
	MOVAPS xmm6, [byte rsp + 16]                                           ; 
	ADD rsp, 40                                                            ; 
	RET                                                                    ; rsp
