section .rodata.Nehalem progbits alloc noexec nowrite align=16
_yepMath_Sin_V64f_V64f_Nehalem_constants:
	.c0: DQ 0x3FE45F306DC9C883, 0x3FE45F306DC9C883
	.c1: DQ 0x4338000000000000, 0x4338000000000000
	.c2: DQ 0xBFF921FB54440000, 0xBFF921FB54440000
	.c3: DQ 0xBD868C234C4C8000, 0xBD868C234C4C8000
	.c4: DQ 0x3B09D747F23E32ED, 0x3B09D747F23E32ED
	.c5: DQ 0xBDA8FA87EF79AE3F, 0xBDA8FA87EF79AE3F
	.c6: DQ 0x3DE5D8711D281543, 0x3DE5D8711D281543
	.c7: DQ 0x3E21EE9DF6693F7E, 0x3E21EE9DF6693F7E
	.c8: DQ 0xBE5AE5E38936D046, 0xBE5AE5E38936D046
	.c9: DQ 0xBE927E4F7F65104F, 0xBE927E4F7F65104F
	.c10: DQ 0x3EC71DE3535C8A8A, 0x3EC71DE3535C8A8A
	.c11: DQ 0x3EFA01A019C94874, 0x3EFA01A019C94874
	.c12: DQ 0xBF2A01A019BB92C0, 0xBF2A01A019BB92C0
	.c13: DQ 0xBF56C16C16C15038, 0xBF56C16C16C15038
	.c14: DQ 0x3F8111111110F51E, 0x3F8111111110F51E
	.c15: DQ 0x3FA555555555554B, 0x3FA555555555554B
	.c16: DQ 0xBFC5555555555546, 0xBFC5555555555546
	.c17: DQ 0xBFE0000000000000, 0xBFE0000000000000
	.c18: DQ 0x3FF0000000000000, 0x3FF0000000000000
	.c19: DQ 0x8000000000000000, 0x8000000000000000


section .text.Nehalem progbits alloc exec nowrite align=16
global _yepMath_Sin_V64f_V64f_Nehalem
_yepMath_Sin_V64f_V64f_Nehalem:
	.ENTRY:
	SUB rsp, 168                                                           ; 
	MOV rax, rdi                                                           ; rdi, rdx, rsi, rsp
	MOV r10, rsi                                                           ; rax, rdx, rsi, rsp
	MOV r11, rdx                                                           ; r10, rax, rdx, rsp
	CMP r11, 0                                                             ; r10, r11, rax, rsp
	JZ .returnOk                                                           ; r10, r11, rax, rsp
	TEST rax, 31                                                           ; r10, r11, rax, rsp
	JZ .source_32b_aligned                                                 ; r10, r11, rax, rsp
	.source_32b_misaligned:
	MOVSD xmm1, [rax]                                                      ; r10, r11, rax, rsp
	MOVAPS xmm2, xmm1                                                      ; r10, r11, rax, rsp, xmm1
	MULPD xmm2, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c0]     ; r10, r11, rax, rsp, xmm1, xmm2
	ADDPD xmm2, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c1]     ; r10, r11, rax, rsp, xmm1, xmm2
	MOVAPS xmm0, xmm2                                                      ; r10, r11, rax, rsp, xmm1, xmm2
	PSLLQ xmm0, 62                                                         ; r10, r11, rax, rsp, xmm0, xmm1, xmm2
	SUBPD xmm2, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c1]     ; r10, r11, rax, rsp, xmm0, xmm1, xmm2
	MOVAPS xmm3, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c2]    ; r10, r11, rax, rsp, xmm0, xmm1, xmm2
	MULPD xmm3, xmm2                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3
	ADDPD xmm1, xmm3                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3
	MOVAPS xmm3, xmm1                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm2
	MOVAPS xmm4, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c3]    ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3
	MULPD xmm4, xmm2                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	ADDPD xmm1, xmm4                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	MOVAPS xmm5, xmm1                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	SUBPD xmm5, xmm3                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	SUBPD xmm4, xmm5                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm4, xmm5
	MULPD xmm2, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c4]     ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm4
	ADDPD xmm2, xmm4                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm4
	ADDPD xmm1, xmm2                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2
	MOVAPS xmm4, xmm1                                                      ; r10, r11, rax, rsp, xmm0, xmm1
	MULPD xmm4, xmm4                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm4
	MOVAPD xmm3, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c5]    ; 
	MOVAPD xmm2, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c6]    ; 
	MULPD xmm3, xmm4                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	ADDPD xmm3, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c7]     ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	MULPD xmm2, xmm4                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	ADDPD xmm2, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c8]     ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	MULPD xmm3, xmm4                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	ADDPD xmm3, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c9]     ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	MULPD xmm2, xmm4                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	ADDPD xmm2, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c10]    ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	MULPD xmm3, xmm4                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	ADDPD xmm3, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c11]    ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	MULPD xmm2, xmm4                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	ADDPD xmm2, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c12]    ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	MULPD xmm3, xmm4                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	ADDPD xmm3, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c13]    ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	MULPD xmm2, xmm4                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	ADDPD xmm2, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c14]    ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	MULPD xmm3, xmm4                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	ADDPD xmm3, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c15]    ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	MULPD xmm2, xmm4                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	ADDPD xmm2, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c16]    ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	MULPD xmm3, xmm4                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	ADDPD xmm3, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c17]    ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	MULPD xmm2, xmm4                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	MULPD xmm3, xmm4                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	MULPD xmm2, xmm1                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3
	ADDPD xmm2, xmm1                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3
	ADDPD xmm3, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c18]    ; r10, r11, rax, rsp, xmm0, xmm2, xmm3
	MOVAPD xmm1, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c19]   ; 
	PAND xmm1, xmm0                                                        ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3
	PADDQ xmm0, xmm0                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3
	BLENDVPD xmm2, xmm3, xmm0                                              ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3
	XORPD xmm2, xmm1                                                       ; r10, r11, rax, rsp, xmm1, xmm2
	MOVSD [r10], xmm2                                                      ; r10, r11, rax, rsp, xmm2
	ADD rax, 8                                                             ; r10, r11, rax, rsp
	ADD r10, 8                                                             ; r10, r11, rax, rsp
	SUB r11, 1                                                             ; r10, r11, rax, rsp
	JZ .returnOk                                                           ; r10, r11, rax, rsp
	TEST rax, 31                                                           ; r10, r11, rax, rsp
	JNZ .source_32b_misaligned                                             ; r10, r11, rax, rsp
	.source_32b_aligned:
	SUB r11, 10                                                            ; r10, r11, rax, rsp
	JB .process_restore                                                    ; r10, r11, rax, rsp
	align 32
	.process_batch:
	MOVAPD xmm4, [rax]                                                     ; r10, r11, rax, rsp
	MOVAPS xmm9, xmm4                                                      ; r10, r11, rax, rsp, xmm4
	MULPD xmm9, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c0]     ; r10, r11, rax, rsp, xmm4, xmm9
	ADDPD xmm9, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c1]     ; r10, r11, rax, rsp, xmm4, xmm9
	MOVAPD xmm3, [byte rax + 16]                                           ; r10, r11, rax, rsp, xmm4, xmm9
	MOVAPS xmm8, xmm3                                                      ; r10, r11, rax, rsp, xmm3, xmm4, xmm9
	MULPD xmm8, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c0]     ; r10, r11, rax, rsp, xmm3, xmm4, xmm8, xmm9
	ADDPD xmm8, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c1]     ; r10, r11, rax, rsp, xmm3, xmm4, xmm8, xmm9
	MOVAPD xmm2, [byte rax + 32]                                           ; r10, r11, rax, rsp, xmm3, xmm4, xmm8, xmm9
	MOVAPS xmm7, xmm2                                                      ; r10, r11, rax, rsp, xmm2, xmm3, xmm4, xmm8, xmm9
	MULPD xmm7, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c0]     ; r10, r11, rax, rsp, xmm2, xmm3, xmm4, xmm7, xmm8, xmm9
	ADDPD xmm7, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c1]     ; r10, r11, rax, rsp, xmm2, xmm3, xmm4, xmm7, xmm8, xmm9
	MOVAPD xmm1, [byte rax + 48]                                           ; r10, r11, rax, rsp, xmm2, xmm3, xmm4, xmm7, xmm8, xmm9
	MOVAPS xmm6, xmm1                                                      ; r10, r11, rax, rsp, xmm1, xmm2, xmm3, xmm4, xmm7, xmm8, xmm9
	MULPD xmm6, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c0]     ; r10, r11, rax, rsp, xmm1, xmm2, xmm3, xmm4, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm6, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c1]     ; r10, r11, rax, rsp, xmm1, xmm2, xmm3, xmm4, xmm6, xmm7, xmm8, xmm9
	MOVAPD xmm0, [byte rax + 64]                                           ; r10, r11, rax, rsp, xmm1, xmm2, xmm3, xmm4, xmm6, xmm7, xmm8, xmm9
	MOVAPS xmm5, xmm0                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm6, xmm7, xmm8, xmm9
	MULPD xmm5, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c0]     ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm5, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c1]     ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVAPS xmm10, xmm9                                                     ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	PSLLQ xmm10, 62                                                        ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVDQA oword [rsp], xmm10                                              ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	SUBPD xmm9, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c1]     ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVAPS xmm10, xmm8                                                     ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	PSLLQ xmm10, 62                                                        ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVDQA oword [rsp + 16], xmm10                                         ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	SUBPD xmm8, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c1]     ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVAPS xmm10, xmm7                                                     ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	PSLLQ xmm10, 62                                                        ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVDQA oword [rsp + 32], xmm10                                         ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	SUBPD xmm7, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c1]     ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVAPS xmm10, xmm6                                                     ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	PSLLQ xmm10, 62                                                        ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVDQA oword [rsp + 48], xmm10                                         ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	SUBPD xmm6, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c1]     ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVAPS xmm10, xmm5                                                     ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	PSLLQ xmm10, 62                                                        ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVDQA oword [rsp + 64], xmm10                                         ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	SUBPD xmm5, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c1]     ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVAPS xmm10, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c2]   ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm10, xmm9                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm4, xmm10                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVAPS xmm10, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c2]   ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm10, xmm8                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm3, xmm10                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVAPS xmm10, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c2]   ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm10, xmm7                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm2, xmm10                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVAPS xmm10, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c2]   ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm10, xmm6                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm1, xmm10                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVAPS xmm10, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c2]   ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm10, xmm5                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm0, xmm10                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVAPS xmm11, xmm4                                                     ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVAPS xmm10, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c3]   ; r10, r11, rax, rsp, xmm0, xmm1, xmm11, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm10, xmm9                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm4, xmm10                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVAPS xmm12, xmm4                                                     ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	SUBPD xmm12, xmm11                                                     ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	SUBPD xmm10, xmm12                                                     ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm12, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm9, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c4]     ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm9, xmm10                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm4, xmm9                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVAPS xmm11, xmm3                                                     ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8
	MOVAPS xmm9, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c3]    ; r10, r11, rax, rsp, xmm0, xmm1, xmm11, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8
	MULPD xmm9, xmm8                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm11, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm3, xmm9                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm11, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVAPS xmm10, xmm3                                                     ; r10, r11, rax, rsp, xmm0, xmm1, xmm11, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	SUBPD xmm10, xmm11                                                     ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	SUBPD xmm9, xmm10                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm8, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c4]     ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm8, xmm9                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm3, xmm8                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8
	MOVAPS xmm9, xmm2                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVAPS xmm8, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c3]    ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm9
	MULPD xmm8, xmm7                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm2, xmm8                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVAPS xmm10, xmm2                                                     ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	SUBPD xmm10, xmm9                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	SUBPD xmm8, xmm10                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8
	MULPD xmm7, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c4]     ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8
	ADDPD xmm7, xmm8                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8
	ADDPD xmm2, xmm7                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MOVAPS xmm8, xmm1                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	MOVAPS xmm7, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c3]    ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm8
	MULPD xmm7, xmm6                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8
	ADDPD xmm1, xmm7                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8
	MOVAPS xmm9, xmm1                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8
	SUBPD xmm9, xmm8                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	SUBPD xmm7, xmm9                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm9
	MULPD xmm6, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c4]     ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	ADDPD xmm6, xmm7                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	ADDPD xmm1, xmm6                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	MOVAPS xmm8, xmm0                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	MOVAPS xmm6, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c3]    ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm8
	MULPD xmm6, xmm5                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm8
	ADDPD xmm0, xmm6                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm8
	MOVAPS xmm7, xmm0                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm8
	SUBPD xmm7, xmm8                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8
	SUBPD xmm6, xmm7                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7
	MULPD xmm5, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c4]     ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	ADDPD xmm5, xmm6                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	ADDPD xmm0, xmm5                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	MOVAPD oword [rsp + 80], xmm4                                          ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	MULPD xmm4, xmm4                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	MOVAPD oword [rsp + 96], xmm3                                          ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	MULPD xmm3, xmm3                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	MOVAPD oword [rsp + 112], xmm2                                         ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	MULPD xmm2, xmm2                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	MOVAPD oword [rsp + 128], xmm1                                         ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	MULPD xmm1, xmm1                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	MOVAPD oword [rsp + 144], xmm0                                         ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	MULPD xmm0, xmm0                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	MOVAPD xmm14, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c5]   ; 
	MOVAPD xmm13, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c6]   ; 
	MOVAPD xmm12, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c5]   ; 
	MOVAPD xmm11, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c6]   ; 
	MOVAPD xmm9, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c5]    ; 
	MOVAPD xmm10, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c6]   ; 
	MOVAPD xmm8, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c5]    ; 
	MOVAPD xmm7, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c6]    ; 
	MOVAPD xmm5, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c5]    ; 
	MOVAPD xmm6, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c6]    ; 
	MOVAPD xmm15, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c7]   ; 
	MULPD xmm14, xmm4                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm14, xmm15                                                     ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm12, xmm3                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm12, xmm15                                                     ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm9, xmm2                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm9, xmm15                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm8, xmm1                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm8, xmm15                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm5, xmm0                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm5, xmm15                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVAPD xmm15, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c8]   ; 
	MULPD xmm13, xmm4                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm13, xmm15                                                     ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm11, xmm3                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm11, xmm15                                                     ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm10, xmm2                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm10, xmm15                                                     ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm7, xmm1                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm7, xmm15                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm6, xmm0                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm6, xmm15                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVAPD xmm15, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c9]   ; 
	MULPD xmm14, xmm4                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm14, xmm15                                                     ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm12, xmm3                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm12, xmm15                                                     ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm9, xmm2                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm9, xmm15                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm8, xmm1                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm8, xmm15                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm5, xmm0                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm5, xmm15                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVAPD xmm15, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c10]  ; 
	MULPD xmm13, xmm4                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm13, xmm15                                                     ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm11, xmm3                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm11, xmm15                                                     ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm10, xmm2                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm10, xmm15                                                     ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm7, xmm1                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm7, xmm15                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm6, xmm0                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm6, xmm15                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVAPD xmm15, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c11]  ; 
	MULPD xmm14, xmm4                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm14, xmm15                                                     ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm12, xmm3                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm12, xmm15                                                     ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm9, xmm2                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm9, xmm15                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm8, xmm1                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm8, xmm15                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm5, xmm0                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm5, xmm15                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVAPD xmm15, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c12]  ; 
	MULPD xmm13, xmm4                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm13, xmm15                                                     ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm11, xmm3                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm11, xmm15                                                     ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm10, xmm2                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm10, xmm15                                                     ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm7, xmm1                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm7, xmm15                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm6, xmm0                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm6, xmm15                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVAPD xmm15, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c13]  ; 
	MULPD xmm14, xmm4                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm14, xmm15                                                     ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm12, xmm3                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm12, xmm15                                                     ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm9, xmm2                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm9, xmm15                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm8, xmm1                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm8, xmm15                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm5, xmm0                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm5, xmm15                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVAPD xmm15, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c14]  ; 
	MULPD xmm13, xmm4                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm13, xmm15                                                     ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm11, xmm3                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm11, xmm15                                                     ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm10, xmm2                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm10, xmm15                                                     ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm7, xmm1                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm7, xmm15                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm6, xmm0                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm6, xmm15                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVAPD xmm15, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c15]  ; 
	MULPD xmm14, xmm4                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm14, xmm15                                                     ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm12, xmm3                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm12, xmm15                                                     ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm9, xmm2                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm9, xmm15                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm8, xmm1                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm8, xmm15                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm5, xmm0                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm5, xmm15                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVAPD xmm15, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c16]  ; 
	MULPD xmm13, xmm4                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm13, xmm15                                                     ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm11, xmm3                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm11, xmm15                                                     ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm10, xmm2                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm10, xmm15                                                     ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm7, xmm1                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm7, xmm15                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm6, xmm0                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm6, xmm15                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVAPD xmm15, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c17]  ; 
	MULPD xmm14, xmm4                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm14, xmm15                                                     ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm12, xmm3                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm12, xmm15                                                     ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm9, xmm2                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm9, xmm15                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm8, xmm1                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm8, xmm15                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm5, xmm0                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm5, xmm15                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm13, xmm4                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm14, xmm4                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVAPD xmm4, oword [rsp + 80]                                          ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm2, xmm3, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm13, xmm4                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm13, xmm4                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm14, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c18]   ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm2, xmm3, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm11, xmm3                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm2, xmm3, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm12, xmm3                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm2, xmm3, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVAPD xmm3, oword [rsp + 96]                                          ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm2, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm11, xmm3                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm2, xmm3, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm11, xmm3                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm2, xmm3, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm12, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c18]   ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm2, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm10, xmm2                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm2, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm9, xmm2                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm2, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVAPD xmm2, oword [rsp + 112]                                         ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm10, xmm2                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm2, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm10, xmm2                                                      ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm2, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm9, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c18]    ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm7, xmm1                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm8, xmm1                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVAPD xmm1, oword [rsp + 128]                                         ; r10, r11, rax, rsp, xmm0, xmm10, xmm11, xmm12, xmm13, xmm14, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm7, xmm1                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm7, xmm1                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm8, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c18]    ; r10, r11, rax, rsp, xmm0, xmm10, xmm11, xmm12, xmm13, xmm14, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm6, xmm0                                                       ; r10, r11, rax, rsp, xmm0, xmm10, xmm11, xmm12, xmm13, xmm14, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm5, xmm0                                                       ; r10, r11, rax, rsp, xmm0, xmm10, xmm11, xmm12, xmm13, xmm14, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVAPD xmm0, oword [rsp + 144]                                         ; r10, r11, rax, rsp, xmm10, xmm11, xmm12, xmm13, xmm14, xmm5, xmm6, xmm7, xmm8, xmm9
	MULPD xmm6, xmm0                                                       ; r10, r11, rax, rsp, xmm0, xmm10, xmm11, xmm12, xmm13, xmm14, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm6, xmm0                                                       ; r10, r11, rax, rsp, xmm0, xmm10, xmm11, xmm12, xmm13, xmm14, xmm5, xmm6, xmm7, xmm8, xmm9
	ADDPD xmm5, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c18]    ; r10, r11, rax, rsp, xmm10, xmm11, xmm12, xmm13, xmm14, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVAPD xmm0, oword [rsp]                                               ; r10, r11, rax, rsp, xmm10, xmm11, xmm12, xmm13, xmm14, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVAPD xmm1, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c19]   ; 
	PAND xmm1, xmm0                                                        ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm5, xmm6, xmm7, xmm8, xmm9
	PADDQ xmm0, xmm0                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm5, xmm6, xmm7, xmm8, xmm9
	BLENDVPD xmm13, xmm14, xmm0                                            ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm13, xmm14, xmm5, xmm6, xmm7, xmm8, xmm9
	XORPD xmm13, xmm1                                                      ; r10, r11, rax, rsp, xmm1, xmm10, xmm11, xmm12, xmm13, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVUPD [r10], xmm13                                                    ; r10, r11, rax, rsp, xmm10, xmm11, xmm12, xmm13, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVAPD xmm0, oword [rsp + 16]                                          ; r10, r11, rax, rsp, xmm10, xmm11, xmm12, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVAPD xmm1, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c19]   ; 
	PAND xmm1, xmm0                                                        ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm5, xmm6, xmm7, xmm8, xmm9
	PADDQ xmm0, xmm0                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm5, xmm6, xmm7, xmm8, xmm9
	BLENDVPD xmm11, xmm12, xmm0                                            ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm11, xmm12, xmm5, xmm6, xmm7, xmm8, xmm9
	XORPD xmm11, xmm1                                                      ; r10, r11, rax, rsp, xmm1, xmm10, xmm11, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVUPD [byte r10 + 16], xmm11                                          ; r10, r11, rax, rsp, xmm10, xmm11, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVAPD xmm0, oword [rsp + 32]                                          ; r10, r11, rax, rsp, xmm10, xmm5, xmm6, xmm7, xmm8, xmm9
	MOVAPD xmm1, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c19]   ; 
	PAND xmm1, xmm0                                                        ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm5, xmm6, xmm7, xmm8, xmm9
	PADDQ xmm0, xmm0                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm5, xmm6, xmm7, xmm8, xmm9
	BLENDVPD xmm10, xmm9, xmm0                                             ; r10, r11, rax, rsp, xmm0, xmm1, xmm10, xmm5, xmm6, xmm7, xmm8, xmm9
	XORPD xmm10, xmm1                                                      ; r10, r11, rax, rsp, xmm1, xmm10, xmm5, xmm6, xmm7, xmm8
	MOVUPD [byte r10 + 32], xmm10                                          ; r10, r11, rax, rsp, xmm10, xmm5, xmm6, xmm7, xmm8
	MOVAPD xmm0, oword [rsp + 48]                                          ; r10, r11, rax, rsp, xmm5, xmm6, xmm7, xmm8
	MOVAPD xmm1, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c19]   ; 
	PAND xmm1, xmm0                                                        ; r10, r11, rax, rsp, xmm0, xmm1, xmm5, xmm6, xmm7, xmm8
	PADDQ xmm0, xmm0                                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm5, xmm6, xmm7, xmm8
	BLENDVPD xmm7, xmm8, xmm0                                              ; r10, r11, rax, rsp, xmm0, xmm1, xmm5, xmm6, xmm7, xmm8
	XORPD xmm7, xmm1                                                       ; r10, r11, rax, rsp, xmm1, xmm5, xmm6, xmm7
	MOVUPD [byte r10 + 48], xmm7                                           ; r10, r11, rax, rsp, xmm5, xmm6, xmm7
	MOVAPD xmm0, oword [rsp + 64]                                          ; r10, r11, rax, rsp, xmm5, xmm6
	MOVAPD xmm1, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c19]   ; 
	PAND xmm1, xmm0                                                        ; r10, r11, rax, xmm0, xmm1, xmm5, xmm6
	PADDQ xmm0, xmm0                                                       ; r10, r11, rax, xmm0, xmm1, xmm5, xmm6
	BLENDVPD xmm6, xmm5, xmm0                                              ; r10, r11, rax, xmm0, xmm1, xmm5, xmm6
	XORPD xmm6, xmm1                                                       ; r10, r11, rax, xmm1, xmm6
	MOVUPD [byte r10 + 64], xmm6                                           ; r10, r11, rax, xmm6
	ADD rax, 80                                                            ; r10, r11, rax
	ADD r10, 80                                                            ; r10, r11, rax
	SUB r11, 10                                                            ; r10, r11, rax
	JAE .process_batch                                                     ; r10, r11, rax
	.process_restore:
	ADD r11, 10                                                            ; r10, r11, rax
	JZ .returnOk                                                           ; r10, r11, rax
	.process_single:
	MOVSD xmm1, [rax]                                                      ; r10, r11, rax
	MOVAPS xmm2, xmm1                                                      ; r10, r11, rax, xmm1
	MULPD xmm2, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c0]     ; r10, r11, rax, xmm1, xmm2
	ADDPD xmm2, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c1]     ; r10, r11, rax, xmm1, xmm2
	MOVAPS xmm0, xmm2                                                      ; r10, r11, rax, xmm1, xmm2
	PSLLQ xmm0, 62                                                         ; r10, r11, rax, xmm0, xmm1, xmm2
	SUBPD xmm2, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c1]     ; r10, r11, rax, xmm0, xmm1, xmm2
	MOVAPS xmm3, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c2]    ; r10, r11, rax, xmm0, xmm1, xmm2
	MULPD xmm3, xmm2                                                       ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3
	ADDPD xmm1, xmm3                                                       ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3
	MOVAPS xmm4, xmm1                                                      ; r10, r11, rax, xmm0, xmm1, xmm2
	MOVAPS xmm3, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c3]    ; r10, r11, rax, xmm0, xmm1, xmm2, xmm4
	MULPD xmm3, xmm2                                                       ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	ADDPD xmm1, xmm3                                                       ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	MOVAPS xmm5, xmm1                                                      ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	SUBPD xmm5, xmm4                                                       ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	SUBPD xmm3, xmm5                                                       ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm5
	MULPD xmm2, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c4]     ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3
	ADDPD xmm2, xmm3                                                       ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3
	ADDPD xmm1, xmm2                                                       ; r10, r11, rax, xmm0, xmm1, xmm2
	MOVAPS xmm4, xmm1                                                      ; r10, r11, rax, xmm0, xmm1
	MULPD xmm4, xmm4                                                       ; r10, r11, rax, xmm0, xmm1, xmm4
	MOVAPD xmm3, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c5]    ; 
	MOVAPD xmm2, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c6]    ; 
	MULPD xmm3, xmm4                                                       ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	ADDPD xmm3, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c7]     ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	MULPD xmm2, xmm4                                                       ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	ADDPD xmm2, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c8]     ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	MULPD xmm3, xmm4                                                       ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	ADDPD xmm3, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c9]     ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	MULPD xmm2, xmm4                                                       ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	ADDPD xmm2, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c10]    ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	MULPD xmm3, xmm4                                                       ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	ADDPD xmm3, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c11]    ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	MULPD xmm2, xmm4                                                       ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	ADDPD xmm2, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c12]    ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	MULPD xmm3, xmm4                                                       ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	ADDPD xmm3, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c13]    ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	MULPD xmm2, xmm4                                                       ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	ADDPD xmm2, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c14]    ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	MULPD xmm3, xmm4                                                       ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	ADDPD xmm3, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c15]    ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	MULPD xmm2, xmm4                                                       ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	ADDPD xmm2, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c16]    ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	MULPD xmm3, xmm4                                                       ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	ADDPD xmm3, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c17]    ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	MULPD xmm2, xmm4                                                       ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	MULPD xmm3, xmm4                                                       ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	MULPD xmm2, xmm1                                                       ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3
	ADDPD xmm2, xmm1                                                       ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3
	ADDPD xmm3, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c18]    ; r10, r11, rax, xmm0, xmm2, xmm3
	MOVAPD xmm1, oword[rel _yepMath_Sin_V64f_V64f_Nehalem_constants.c19]   ; 
	PAND xmm1, xmm0                                                        ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3
	PADDQ xmm0, xmm0                                                       ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3
	BLENDVPD xmm2, xmm3, xmm0                                              ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3
	XORPD xmm2, xmm1                                                       ; r10, r11, rax, xmm1, xmm2
	MOVSD [r10], xmm2                                                      ; r10, r11, rax, xmm2
	ADD rax, 8                                                             ; r10, r11, rax
	ADD r10, 8                                                             ; r10, r11
	SUB r11, 1                                                             ; r11
	JNZ .process_single                                                    ; 
	.returnOk:
	ADD rsp, 168                                                           ; 
	XOR eax, eax                                                           ; 
	RET                                                                    ; 

section .rodata.SandyBridge progbits alloc noexec nowrite align=32
_yepMath_Sin_V64f_V64f_SandyBridge_constants:
	.c0: DQ 0x3FE45F306DC9C883, 0x3FE45F306DC9C883
	.c1: DQ 0x4338000000000000, 0x4338000000000000
	.c2: DQ 0xBFF921FB54440000, 0xBFF921FB54440000
	.c3: DQ 0xBD868C234C4C8000, 0xBD868C234C4C8000
	.c4: DQ 0x3B09D747F23E32ED, 0x3B09D747F23E32ED
	.c5: DQ 0xBDA8FA87EF79AE3F, 0xBDA8FA87EF79AE3F
	.c6: DQ 0x3DE5D8711D281543, 0x3DE5D8711D281543
	.c7: DQ 0x3E21EE9DF6693F7E, 0x3E21EE9DF6693F7E
	.c8: DQ 0xBE5AE5E38936D046, 0xBE5AE5E38936D046
	.c9: DQ 0xBE927E4F7F65104F, 0xBE927E4F7F65104F
	.c10: DQ 0x3EC71DE3535C8A8A, 0x3EC71DE3535C8A8A
	.c11: DQ 0x3EFA01A019C94874, 0x3EFA01A019C94874
	.c12: DQ 0xBF2A01A019BB92C0, 0xBF2A01A019BB92C0
	.c13: DQ 0xBF56C16C16C15038, 0xBF56C16C16C15038
	.c14: DQ 0x3F8111111110F51E, 0x3F8111111110F51E
	.c15: DQ 0x3FA555555555554B, 0x3FA555555555554B
	.c16: DQ 0xBFC5555555555546, 0xBFC5555555555546
	.c17: DQ 0xBFE0000000000000, 0xBFE0000000000000
	.c18: DQ 0x3FF0000000000000, 0x3FF0000000000000
	.c19: DQ 0x8000000000000000, 0x8000000000000000
	.c20: DQ 0x3FE45F306DC9C883, 0x3FE45F306DC9C883, 0x3FE45F306DC9C883, 0x3FE45F306DC9C883
	.c21: DQ 0x4338000000000000, 0x4338000000000000, 0x4338000000000000, 0x4338000000000000
	.c22: DQ 0xBFF921FB54440000, 0xBFF921FB54440000, 0xBFF921FB54440000, 0xBFF921FB54440000
	.c23: DQ 0xBD868C234C4C8000, 0xBD868C234C4C8000, 0xBD868C234C4C8000, 0xBD868C234C4C8000
	.c24: DQ 0x3B09D747F23E32ED, 0x3B09D747F23E32ED, 0x3B09D747F23E32ED, 0x3B09D747F23E32ED
	.c25: DQ 0xBDA8FA87EF79AE3F, 0xBDA8FA87EF79AE3F, 0xBDA8FA87EF79AE3F, 0xBDA8FA87EF79AE3F
	.c26: DQ 0x3E21EE9DF6693F7E, 0x3E21EE9DF6693F7E, 0x3E21EE9DF6693F7E, 0x3E21EE9DF6693F7E
	.c27: DQ 0x3DE5D8711D281543, 0x3DE5D8711D281543, 0x3DE5D8711D281543, 0x3DE5D8711D281543
	.c28: DQ 0xBE5AE5E38936D046, 0xBE5AE5E38936D046, 0xBE5AE5E38936D046, 0xBE5AE5E38936D046
	.c29: DQ 0xBE927E4F7F65104F, 0xBE927E4F7F65104F, 0xBE927E4F7F65104F, 0xBE927E4F7F65104F
	.c30: DQ 0x3EC71DE3535C8A8A, 0x3EC71DE3535C8A8A, 0x3EC71DE3535C8A8A, 0x3EC71DE3535C8A8A
	.c31: DQ 0x3EFA01A019C94874, 0x3EFA01A019C94874, 0x3EFA01A019C94874, 0x3EFA01A019C94874
	.c32: DQ 0xBF2A01A019BB92C0, 0xBF2A01A019BB92C0, 0xBF2A01A019BB92C0, 0xBF2A01A019BB92C0
	.c33: DQ 0xBF56C16C16C15038, 0xBF56C16C16C15038, 0xBF56C16C16C15038, 0xBF56C16C16C15038
	.c34: DQ 0x3F8111111110F51E, 0x3F8111111110F51E, 0x3F8111111110F51E, 0x3F8111111110F51E
	.c35: DQ 0x3FA555555555554B, 0x3FA555555555554B, 0x3FA555555555554B, 0x3FA555555555554B
	.c36: DQ 0xBFC5555555555546, 0xBFC5555555555546, 0xBFC5555555555546, 0xBFC5555555555546
	.c37: DQ 0xBFE0000000000000, 0xBFE0000000000000, 0xBFE0000000000000, 0xBFE0000000000000
	.c38: DQ 0x3FF0000000000000, 0x3FF0000000000000, 0x3FF0000000000000, 0x3FF0000000000000
	.c39: DQ 0x8000000000000000, 0x8000000000000000, 0x8000000000000000, 0x8000000000000000


section .text.SandyBridge progbits alloc exec nowrite align=16
global _yepMath_Sin_V64f_V64f_SandyBridge
_yepMath_Sin_V64f_V64f_SandyBridge:
	.ENTRY:
	MOV rax, rsp                                                           ; 
	SUB rsp, 8                                                             ; 
	AND rsp, -32                                                           ; 
	MOV [rsp], rax                                                         ; 
	SUB rsp, 320                                                           ; 
	MOV rax, rdi                                                           ; rdi, rdx, rsi, rsp
	MOV r10, rsi                                                           ; rax, rdx, rsi, rsp
	MOV r11, rdx                                                           ; r10, rax, rdx, rsp
	CMP r11, 0                                                             ; r10, r11, rax, rsp
	JZ .returnOk                                                           ; r10, r11, rax, rsp
	TEST rax, 31                                                           ; r10, r11, rax, rsp
	JZ .source_32b_aligned                                                 ; r10, r11, rax, rsp
	.source_32b_misaligned:
	VMOVSD xmm1, [rax]                                                     ; r10, r11, rax, rsp
	VMULPD xmm2, xmm1, oword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c0] ; r10, r11, rax, rsp, xmm1
	VADDPD xmm2, xmm2, oword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c1] ; r10, r11, rax, rsp, xmm1, xmm2
	VPSLLQ xmm0, xmm2, 62                                                  ; r10, r11, rax, rsp, xmm1, xmm2
	VSUBPD xmm2, xmm2, oword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c1] ; r10, r11, rax, rsp, xmm0, xmm1, xmm2
	VMULPD xmm3, xmm2, oword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c2] ; r10, r11, rax, rsp, xmm0, xmm1, xmm2
	VADDPD xmm1, xmm1, xmm3                                                ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3
	VMOVAPS xmm4, xmm1                                                     ; r10, r11, rax, rsp, xmm0, xmm1, xmm2
	VMULPD xmm3, xmm2, oword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c3] ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm4
	VADDPD xmm1, xmm1, xmm3                                                ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VSUBPD xmm4, xmm1, xmm4                                                ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VSUBPD xmm3, xmm3, xmm4                                                ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VMULPD xmm2, xmm2, oword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c4] ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3
	VADDPD xmm2, xmm2, xmm3                                                ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3
	VADDPD xmm1, xmm1, xmm2                                                ; r10, r11, rax, rsp, xmm0, xmm1, xmm2
	VMULPD xmm4, xmm1, xmm1                                                ; r10, r11, rax, rsp, xmm0, xmm1
	VMOVAPD xmm3, oword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c5] ; 
	VMOVAPD xmm2, oword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c6] ; 
	VMULPD xmm3, xmm3, xmm4                                                ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VADDPD xmm3, xmm3, oword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c7] ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VMULPD xmm2, xmm2, xmm4                                                ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VADDPD xmm2, xmm2, oword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c8] ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VMULPD xmm3, xmm3, xmm4                                                ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VADDPD xmm3, xmm3, oword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c9] ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VMULPD xmm2, xmm2, xmm4                                                ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VADDPD xmm2, xmm2, oword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c10] ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VMULPD xmm3, xmm3, xmm4                                                ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VADDPD xmm3, xmm3, oword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c11] ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VMULPD xmm2, xmm2, xmm4                                                ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VADDPD xmm2, xmm2, oword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c12] ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VMULPD xmm3, xmm3, xmm4                                                ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VADDPD xmm3, xmm3, oword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c13] ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VMULPD xmm2, xmm2, xmm4                                                ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VADDPD xmm2, xmm2, oword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c14] ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VMULPD xmm3, xmm3, xmm4                                                ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VADDPD xmm3, xmm3, oword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c15] ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VMULPD xmm2, xmm2, xmm4                                                ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VADDPD xmm2, xmm2, oword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c16] ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VMULPD xmm3, xmm3, xmm4                                                ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VADDPD xmm3, xmm3, oword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c17] ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VMULPD xmm2, xmm2, xmm4                                                ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VMULPD xmm3, xmm3, xmm4                                                ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VMULPD xmm2, xmm2, xmm1                                                ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3
	VADDPD xmm2, xmm2, xmm1                                                ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3
	VADDPD xmm3, xmm3, oword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c18] ; r10, r11, rax, rsp, xmm0, xmm2, xmm3
	VMOVAPD xmm1, oword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c19] ; 
	VPAND xmm1, xmm1, xmm0                                                 ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3
	VPADDQ xmm0, xmm0, xmm0                                                ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3
	VBLENDVPD xmm2, xmm2, xmm3, xmm0                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3
	VXORPD xmm2, xmm2, xmm1                                                ; r10, r11, rax, rsp, xmm1, xmm2
	VMOVSD [r10], xmm2                                                     ; r10, r11, rax, rsp, xmm2
	ADD rax, 8                                                             ; r10, r11, rax, rsp
	ADD r10, 8                                                             ; r10, r11, rax, rsp
	SUB r11, 1                                                             ; r10, r11, rax, rsp
	JZ .returnOk                                                           ; r10, r11, rax, rsp
	TEST rax, 31                                                           ; r10, r11, rax, rsp
	JNZ .source_32b_misaligned                                             ; r10, r11, rax, rsp
	.source_32b_aligned:
	SUB r11, 20                                                            ; r10, r11, rax, rsp
	JB .process_restore                                                    ; r10, r11, rax, rsp
	align 32
	.process_batch:
	VMOVAPS ymm1, yword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c20] ; 
	VMOVAPS ymm10, yword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c21] ; 
	VMOVAPD ymm9, [rax]                                                    ; r10, r11, rax, rsp, ymm1, ymm10
	VMULPD ymm8, ymm9, ymm1                                                ; r10, r11, rax, rsp, ymm1, ymm10, ymm9
	VADDPD ymm8, ymm8, ymm10                                               ; r10, r11, rax, rsp, ymm1, ymm10, ymm8, ymm9
	VMOVAPD ymm7, [byte rax + 32]                                          ; r10, r11, rax, rsp, ymm1, ymm10, ymm8, ymm9
	VMULPD ymm6, ymm7, ymm1                                                ; r10, r11, rax, rsp, ymm1, ymm10, ymm7, ymm8, ymm9
	VADDPD ymm6, ymm6, ymm10                                               ; r10, r11, rax, rsp, ymm1, ymm10, ymm6, ymm7, ymm8, ymm9
	VMOVAPD ymm5, [byte rax + 64]                                          ; r10, r11, rax, rsp, ymm1, ymm10, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm4, ymm5, ymm1                                                ; r10, r11, rax, rsp, ymm1, ymm10, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm4, ymm4, ymm10                                               ; r10, r11, rax, rsp, ymm1, ymm10, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVAPD ymm3, [byte rax + 96]                                          ; r10, r11, rax, rsp, ymm1, ymm10, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm2, ymm3, ymm1                                                ; r10, r11, rax, rsp, ymm1, ymm10, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm2, ymm2, ymm10                                               ; r10, r11, rax, rsp, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVAPD ymm0, [dword rax + 128]                                        ; r10, r11, rax, rsp, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm1, ymm0, ymm1                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm1, ymm1, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VEXTRACTF128 xmm12, ymm8, 1                                            ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VPSLLQ xmm11, xmm8, 62                                                 ; r10, r11, rax, rsp, xmm12, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVDQA oword [rsp + 160], xmm11                                       ; r10, r11, rax, rsp, xmm11, xmm12, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VPSLLQ xmm12, xmm12, 62                                                ; r10, r11, rax, rsp, xmm12, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVDQA oword [rsp + 176], xmm12                                       ; r10, r11, rax, rsp, xmm12, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VSUBPD ymm8, ymm8, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VEXTRACTF128 xmm12, ymm6, 1                                            ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VPSLLQ xmm11, xmm6, 62                                                 ; r10, r11, rax, rsp, xmm12, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVDQA oword [rsp + 192], xmm11                                       ; r10, r11, rax, rsp, xmm11, xmm12, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VPSLLQ xmm12, xmm12, 62                                                ; r10, r11, rax, rsp, xmm12, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVDQA oword [rsp + 208], xmm12                                       ; r10, r11, rax, rsp, xmm12, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VSUBPD ymm6, ymm6, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VEXTRACTF128 xmm12, ymm4, 1                                            ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VPSLLQ xmm11, xmm4, 62                                                 ; r10, r11, rax, rsp, xmm12, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVDQA oword [rsp + 224], xmm11                                       ; r10, r11, rax, rsp, xmm11, xmm12, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VPSLLQ xmm12, xmm12, 62                                                ; r10, r11, rax, rsp, xmm12, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVDQA oword [rsp + 240], xmm12                                       ; r10, r11, rax, rsp, xmm12, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VSUBPD ymm4, ymm4, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VEXTRACTF128 xmm11, ymm2, 1                                            ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VPSLLQ xmm12, xmm2, 62                                                 ; r10, r11, rax, rsp, xmm11, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVDQA oword [rsp + 256], xmm12                                       ; r10, r11, rax, rsp, xmm11, xmm12, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VPSLLQ xmm11, xmm11, 62                                                ; r10, r11, rax, rsp, xmm11, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVDQA oword [rsp + 272], xmm11                                       ; r10, r11, rax, rsp, xmm11, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VSUBPD ymm2, ymm2, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VEXTRACTF128 xmm12, ymm1, 1                                            ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VPSLLQ xmm11, xmm1, 62                                                 ; r10, r11, rax, rsp, xmm12, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVDQA oword [rsp + 288], xmm11                                       ; r10, r11, rax, rsp, xmm11, xmm12, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VPSLLQ xmm12, xmm12, 62                                                ; r10, r11, rax, rsp, xmm12, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVDQA oword [rsp + 304], xmm12                                       ; r10, r11, rax, rsp, xmm12, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VSUBPD ymm1, ymm1, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm10, ymm8, yword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c22] ; r10, r11, rax, rsp, ymm0, ymm1, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm9, ymm9, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm10, ymm6, yword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c22] ; r10, r11, rax, rsp, ymm0, ymm1, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm7, ymm7, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm10, ymm4, yword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c22] ; r10, r11, rax, rsp, ymm0, ymm1, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm5, ymm5, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm10, ymm2, yword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c22] ; r10, r11, rax, rsp, ymm0, ymm1, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm3, ymm3, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm10, ymm1, yword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c22] ; r10, r11, rax, rsp, ymm0, ymm1, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm0, ymm0, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm11, ymm8, yword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c23] ; r10, r11, rax, rsp, ymm0, ymm1, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm10, ymm9, ymm11                                              ; r10, r11, rax, rsp, ymm0, ymm1, ymm11, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VSUBPD ymm9, ymm10, ymm9                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VSUBPD ymm11, ymm11, ymm9                                              ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm8, ymm8, yword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c24] ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8
	VADDPD ymm8, ymm8, ymm11                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8
	VADDPD ymm10, ymm10, ymm8                                              ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8
	VMULPD ymm9, ymm6, yword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c23] ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7
	VADDPD ymm8, ymm7, ymm9                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm9
	VSUBPD ymm7, ymm8, ymm7                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VSUBPD ymm9, ymm9, ymm7                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm6, ymm6, yword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c24] ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm8, ymm9
	VADDPD ymm6, ymm6, ymm9                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm8, ymm9
	VADDPD ymm8, ymm8, ymm6                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm8
	VMULPD ymm7, ymm4, yword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c23] ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm8
	VADDPD ymm6, ymm5, ymm7                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm7, ymm8
	VSUBPD ymm5, ymm6, ymm5                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8
	VSUBPD ymm7, ymm7, ymm5                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8
	VMULPD ymm4, ymm4, yword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c24] ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm6, ymm7, ymm8
	VADDPD ymm4, ymm4, ymm7                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm6, ymm7, ymm8
	VADDPD ymm6, ymm6, ymm4                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm6, ymm8
	VMULPD ymm5, ymm2, yword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c23] ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm6, ymm8
	VADDPD ymm4, ymm3, ymm5                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm5, ymm6, ymm8
	VSUBPD ymm3, ymm4, ymm3                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm8
	VSUBPD ymm5, ymm5, ymm3                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm8
	VMULPD ymm2, ymm2, yword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c24] ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm4, ymm5, ymm6, ymm8
	VADDPD ymm2, ymm2, ymm5                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm4, ymm5, ymm6, ymm8
	VADDPD ymm4, ymm4, ymm2                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm4, ymm6, ymm8
	VMULPD ymm3, ymm1, yword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c23] ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm4, ymm6, ymm8
	VADDPD ymm2, ymm0, ymm3                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm3, ymm4, ymm6, ymm8
	VSUBPD ymm0, ymm2, ymm0                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm6, ymm8
	VSUBPD ymm3, ymm3, ymm0                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm6, ymm8
	VMULPD ymm1, ymm1, yword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c24] ; r10, r11, rax, rsp, ymm1, ymm10, ymm2, ymm3, ymm4, ymm6, ymm8
	VADDPD ymm1, ymm1, ymm3                                                ; r10, r11, rax, rsp, ymm1, ymm10, ymm2, ymm3, ymm4, ymm6, ymm8
	VADDPD ymm2, ymm2, ymm1                                                ; r10, r11, rax, rsp, ymm1, ymm10, ymm2, ymm4, ymm6, ymm8
	VMOVAPD yword [rsp], ymm10                                             ; r10, r11, rax, rsp, ymm10, ymm2, ymm4, ymm6, ymm8
	VMULPD ymm12, ymm10, ymm10                                             ; r10, r11, rax, rsp, ymm10, ymm2, ymm4, ymm6, ymm8
	VMOVAPD yword [rsp + 32], ymm8                                         ; r10, r11, rax, rsp, ymm12, ymm2, ymm4, ymm6, ymm8
	VMULPD ymm14, ymm8, ymm8                                               ; r10, r11, rax, rsp, ymm12, ymm2, ymm4, ymm6, ymm8
	VMOVAPD yword [rsp + 64], ymm6                                         ; r10, r11, rax, rsp, ymm12, ymm14, ymm2, ymm4, ymm6
	VMULPD ymm10, ymm6, ymm6                                               ; r10, r11, rax, rsp, ymm12, ymm14, ymm2, ymm4, ymm6
	VMOVAPD yword [rsp + 96], ymm4                                         ; r10, r11, rax, rsp, ymm10, ymm12, ymm14, ymm2, ymm4
	VMULPD ymm11, ymm4, ymm4                                               ; r10, r11, rax, rsp, ymm10, ymm12, ymm14, ymm2, ymm4
	VMOVAPD yword [rsp + 128], ymm2                                        ; r10, r11, rax, rsp, ymm10, ymm11, ymm12, ymm14, ymm2
	VMULPD ymm13, ymm2, ymm2                                               ; r10, r11, rax, rsp, ymm10, ymm11, ymm12, ymm14, ymm2
	VMOVAPS ymm0, yword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c25] ; 
	VMOVAPS ymm2, yword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c26] ; 
	VMULPD ymm8, ymm0, ymm12                                               ; r10, r11, rax, rsp, ymm0, ymm10, ymm11, ymm12, ymm13, ymm14, ymm2
	VADDPD ymm8, ymm8, ymm2                                                ; r10, r11, rax, rsp, ymm0, ymm10, ymm11, ymm12, ymm13, ymm14, ymm2, ymm8
	VMULPD ymm6, ymm0, ymm14                                               ; r10, r11, rax, rsp, ymm0, ymm10, ymm11, ymm12, ymm13, ymm14, ymm2, ymm8
	VADDPD ymm6, ymm6, ymm2                                                ; r10, r11, rax, rsp, ymm0, ymm10, ymm11, ymm12, ymm13, ymm14, ymm2, ymm6, ymm8
	VMULPD ymm4, ymm0, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm10, ymm11, ymm12, ymm13, ymm14, ymm2, ymm6, ymm8
	VADDPD ymm4, ymm4, ymm2                                                ; r10, r11, rax, rsp, ymm0, ymm10, ymm11, ymm12, ymm13, ymm14, ymm2, ymm4, ymm6, ymm8
	VMULPD ymm1, ymm0, ymm11                                               ; r10, r11, rax, rsp, ymm0, ymm10, ymm11, ymm12, ymm13, ymm14, ymm2, ymm4, ymm6, ymm8
	VADDPD ymm1, ymm1, ymm2                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm2, ymm4, ymm6, ymm8
	VMULPD ymm0, ymm0, ymm13                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm2, ymm4, ymm6, ymm8
	VADDPD ymm0, ymm0, ymm2                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm2, ymm4, ymm6, ymm8
	VMOVAPS ymm2, yword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c27] ; 
	VMOVAPS ymm15, yword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c28] ; 
	VMULPD ymm9, ymm2, ymm12                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm4, ymm6, ymm8
	VADDPD ymm9, ymm9, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm4, ymm6, ymm8, ymm9
	VMULPD ymm7, ymm2, ymm14                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm4, ymm6, ymm8, ymm9
	VADDPD ymm7, ymm7, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm4, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm5, ymm2, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm4, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm5, ymm5, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm3, ymm2, ymm11                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm3, ymm3, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm2, ymm2, ymm13                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm2, ymm2, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVAPS ymm15, yword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c29] ; 
	VMULPD ymm8, ymm8, ymm12                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm8, ymm8, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm6, ymm6, ymm14                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm6, ymm6, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm4, ymm4, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm4, ymm4, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm1, ymm1, ymm11                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm1, ymm1, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm0, ymm0, ymm13                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm0, ymm0, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVAPS ymm15, yword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c30] ; 
	VMULPD ymm9, ymm9, ymm12                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm9, ymm9, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm7, ymm7, ymm14                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm7, ymm7, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm5, ymm5, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm5, ymm5, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm3, ymm3, ymm11                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm3, ymm3, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm2, ymm2, ymm13                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm2, ymm2, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVAPS ymm15, yword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c31] ; 
	VMULPD ymm8, ymm8, ymm12                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm8, ymm8, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm6, ymm6, ymm14                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm6, ymm6, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm4, ymm4, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm4, ymm4, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm1, ymm1, ymm11                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm1, ymm1, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm0, ymm0, ymm13                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm0, ymm0, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVAPS ymm15, yword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c32] ; 
	VMULPD ymm9, ymm9, ymm12                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm9, ymm9, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm7, ymm7, ymm14                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm7, ymm7, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm5, ymm5, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm5, ymm5, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm3, ymm3, ymm11                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm3, ymm3, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm2, ymm2, ymm13                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm2, ymm2, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVAPS ymm15, yword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c33] ; 
	VMULPD ymm8, ymm8, ymm12                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm8, ymm8, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm6, ymm6, ymm14                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm6, ymm6, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm4, ymm4, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm4, ymm4, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm1, ymm1, ymm11                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm1, ymm1, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm0, ymm0, ymm13                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm0, ymm0, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVAPS ymm15, yword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c34] ; 
	VMULPD ymm9, ymm9, ymm12                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm9, ymm9, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm7, ymm7, ymm14                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm7, ymm7, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm5, ymm5, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm5, ymm5, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm3, ymm3, ymm11                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm3, ymm3, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm2, ymm2, ymm13                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm2, ymm2, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVAPS ymm15, yword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c35] ; 
	VMULPD ymm8, ymm8, ymm12                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm8, ymm8, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm6, ymm6, ymm14                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm6, ymm6, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm4, ymm4, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm4, ymm4, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm1, ymm1, ymm11                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm1, ymm1, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm0, ymm0, ymm13                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm0, ymm0, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVAPS ymm15, yword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c36] ; 
	VMULPD ymm9, ymm9, ymm12                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm9, ymm9, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm7, ymm7, ymm14                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm7, ymm7, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm5, ymm5, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm5, ymm5, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm3, ymm3, ymm11                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm3, ymm3, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm2, ymm2, ymm13                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm2, ymm2, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVAPS ymm15, yword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c37] ; 
	VMULPD ymm8, ymm8, ymm12                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm8, ymm8, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm6, ymm6, ymm14                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm6, ymm6, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm4, ymm4, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm4, ymm4, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm1, ymm1, ymm11                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm1, ymm1, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm0, ymm0, ymm13                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm0, ymm0, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVAPS ymm15, yword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c38] ; 
	VMULPD ymm9, ymm9, ymm12                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm8, ymm8, ymm12                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVAPD ymm12, yword [rsp]                                             ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm9, ymm9, ymm12                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm9, ymm9, ymm12                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm8, ymm8, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm7, ymm7, ymm14                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm6, ymm6, ymm14                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVAPD ymm12, yword [rsp + 32]                                        ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm13, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm7, ymm7, ymm12                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm7, ymm7, ymm12                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm6, ymm6, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm13, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm5, ymm5, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm13, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm4, ymm4, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm13, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVAPD ymm10, yword [rsp + 64]                                        ; r10, r11, rax, rsp, ymm0, ymm1, ymm11, ymm13, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm5, ymm5, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm13, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm5, ymm5, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm13, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm4, ymm4, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm11, ymm13, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm3, ymm3, ymm11                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm11, ymm13, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm1, ymm1, ymm11                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm11, ymm13, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVAPD ymm10, yword [rsp + 96]                                        ; r10, r11, rax, rsp, ymm0, ymm1, ymm13, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm3, ymm3, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm13, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm3, ymm3, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm13, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm1, ymm1, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm13, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm2, ymm2, ymm13                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm13, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm0, ymm0, ymm13                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm13, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVAPD ymm10, yword [rsp + 128]                                       ; r10, r11, rax, rsp, ymm0, ymm1, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm2, ymm2, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm2, ymm2, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm0, ymm0, ymm15                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVAPS ymm10, yword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c39] ; 
	VMOVAPD ymm11, yword [rsp + 160]                                       ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VANDPD ymm12, ymm11, ymm10                                             ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VANDNPD ymm11, ymm10, ymm11                                            ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VCMPEQPD ymm11, ymm11, ymm12                                           ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VBLENDVPD ymm9, ymm8, ymm9, ymm11                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VXORPD ymm9, ymm9, ymm12                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm12, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm9
	VMOVUPD [r10], xmm9                                                    ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm9
	VEXTRACTF128 [byte r10 + 16], ymm9, 1                                  ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm9
	VMOVAPD ymm8, yword [rsp + 192]                                        ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7
	VANDPD ymm9, ymm8, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8
	VANDNPD ymm8, ymm10, ymm8                                              ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VCMPEQPD ymm8, ymm8, ymm9                                              ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VBLENDVPD ymm7, ymm6, ymm7, ymm8                                       ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VXORPD ymm7, ymm7, ymm9                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm7, ymm9
	VMOVUPD [byte r10 + 32], xmm7                                          ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm7
	VEXTRACTF128 [byte r10 + 48], ymm7, 1                                  ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm7
	VMOVAPD ymm7, yword [rsp + 224]                                        ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5
	VANDPD ymm6, ymm7, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm7
	VANDNPD ymm7, ymm10, ymm7                                              ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7
	VCMPEQPD ymm7, ymm7, ymm6                                              ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7
	VBLENDVPD ymm5, ymm4, ymm5, ymm7                                       ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7
	VXORPD ymm5, ymm5, ymm6                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm5, ymm6
	VMOVUPD [byte r10 + 64], xmm5                                          ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm5
	VEXTRACTF128 [byte r10 + 80], ymm5, 1                                  ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm5
	VMOVAPD ymm5, yword [rsp + 256]                                        ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3
	VANDPD ymm4, ymm5, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm5
	VANDNPD ymm5, ymm10, ymm5                                              ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5
	VCMPEQPD ymm5, ymm5, ymm4                                              ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5
	VBLENDVPD ymm3, ymm1, ymm3, ymm5                                       ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5
	VXORPD ymm3, ymm3, ymm4                                                ; r10, r11, rax, rsp, ymm0, ymm10, ymm2, ymm3, ymm4
	VMOVUPD [byte r10 + 96], xmm3                                          ; r10, r11, rax, rsp, ymm0, ymm10, ymm2, ymm3
	VEXTRACTF128 [byte r10 + 112], ymm3, 1                                 ; r10, r11, rax, rsp, ymm0, ymm10, ymm2, ymm3
	VMOVAPD ymm1, yword [rsp + 288]                                        ; r10, r11, rax, rsp, ymm0, ymm10, ymm2
	VANDPD ymm3, ymm1, ymm10                                               ; r10, r11, rax, ymm0, ymm1, ymm10, ymm2
	VANDNPD ymm1, ymm10, ymm1                                              ; r10, r11, rax, ymm0, ymm1, ymm10, ymm2, ymm3
	VCMPEQPD ymm1, ymm1, ymm3                                              ; r10, r11, rax, ymm0, ymm1, ymm2, ymm3
	VBLENDVPD ymm2, ymm0, ymm2, ymm1                                       ; r10, r11, rax, ymm0, ymm1, ymm2, ymm3
	VXORPD ymm2, ymm2, ymm3                                                ; r10, r11, rax, ymm2, ymm3
	VMOVUPD [dword r10 + 128], xmm2                                        ; r10, r11, rax, ymm2
	VEXTRACTF128 [dword r10 + 144], ymm2, 1                                ; r10, r11, rax, ymm2
	ADD rax, 160                                                           ; r10, r11, rax
	ADD r10, 160                                                           ; r10, r11, rax
	SUB r11, 20                                                            ; r10, r11, rax
	JAE .process_batch                                                     ; r10, r11, rax
	.process_restore:
	ADD r11, 20                                                            ; r10, r11, rax
	JZ .returnOk                                                           ; r10, r11, rax
	.process_single:
	VMOVSD xmm1, [rax]                                                     ; r10, r11, rax
	VMULPD xmm2, xmm1, oword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c0] ; r10, r11, rax, xmm1
	VADDPD xmm2, xmm2, oword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c1] ; r10, r11, rax, xmm1, xmm2
	VPSLLQ xmm0, xmm2, 62                                                  ; r10, r11, rax, xmm1, xmm2
	VSUBPD xmm2, xmm2, oword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c1] ; r10, r11, rax, xmm0, xmm1, xmm2
	VMULPD xmm3, xmm2, oword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c2] ; r10, r11, rax, xmm0, xmm1, xmm2
	VADDPD xmm1, xmm1, xmm3                                                ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3
	VMOVAPS xmm4, xmm1                                                     ; r10, r11, rax, xmm0, xmm1, xmm2
	VMULPD xmm3, xmm2, oword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c3] ; r10, r11, rax, xmm0, xmm1, xmm2, xmm4
	VADDPD xmm1, xmm1, xmm3                                                ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VSUBPD xmm4, xmm1, xmm4                                                ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VSUBPD xmm3, xmm3, xmm4                                                ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VMULPD xmm2, xmm2, oword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c4] ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3
	VADDPD xmm2, xmm2, xmm3                                                ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3
	VADDPD xmm1, xmm1, xmm2                                                ; r10, r11, rax, xmm0, xmm1, xmm2
	VMULPD xmm4, xmm1, xmm1                                                ; r10, r11, rax, xmm0, xmm1
	VMOVAPD xmm3, oword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c5] ; 
	VMOVAPD xmm2, oword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c6] ; 
	VMULPD xmm3, xmm3, xmm4                                                ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VADDPD xmm3, xmm3, oword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c7] ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VMULPD xmm2, xmm2, xmm4                                                ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VADDPD xmm2, xmm2, oword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c8] ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VMULPD xmm3, xmm3, xmm4                                                ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VADDPD xmm3, xmm3, oword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c9] ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VMULPD xmm2, xmm2, xmm4                                                ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VADDPD xmm2, xmm2, oword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c10] ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VMULPD xmm3, xmm3, xmm4                                                ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VADDPD xmm3, xmm3, oword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c11] ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VMULPD xmm2, xmm2, xmm4                                                ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VADDPD xmm2, xmm2, oword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c12] ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VMULPD xmm3, xmm3, xmm4                                                ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VADDPD xmm3, xmm3, oword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c13] ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VMULPD xmm2, xmm2, xmm4                                                ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VADDPD xmm2, xmm2, oword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c14] ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VMULPD xmm3, xmm3, xmm4                                                ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VADDPD xmm3, xmm3, oword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c15] ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VMULPD xmm2, xmm2, xmm4                                                ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VADDPD xmm2, xmm2, oword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c16] ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VMULPD xmm3, xmm3, xmm4                                                ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VADDPD xmm3, xmm3, oword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c17] ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VMULPD xmm2, xmm2, xmm4                                                ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VMULPD xmm3, xmm3, xmm4                                                ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VMULPD xmm2, xmm2, xmm1                                                ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3
	VADDPD xmm2, xmm2, xmm1                                                ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3
	VADDPD xmm3, xmm3, oword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c18] ; r10, r11, rax, xmm0, xmm2, xmm3
	VMOVAPD xmm1, oword[rel _yepMath_Sin_V64f_V64f_SandyBridge_constants.c19] ; 
	VPAND xmm1, xmm1, xmm0                                                 ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3
	VPADDQ xmm0, xmm0, xmm0                                                ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3
	VBLENDVPD xmm2, xmm2, xmm3, xmm0                                       ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3
	VXORPD xmm2, xmm2, xmm1                                                ; r10, r11, rax, xmm1, xmm2
	VMOVSD [r10], xmm2                                                     ; r10, r11, rax, xmm2
	ADD rax, 8                                                             ; r10, r11, rax
	ADD r10, 8                                                             ; r10, r11
	SUB r11, 1                                                             ; r11
	JNZ .process_single                                                    ; 
	.returnOk:
	MOV rsp, [dword rsp + 320]                                             ; 
	XOR eax, eax                                                           ; 
	RET                                                                    ; 

section .rodata.Bulldozer progbits alloc noexec nowrite align=32
_yepMath_Sin_V64f_V64f_Bulldozer_constants:
	.c0: DQ 0x3FE45F306DC9C883, 0x3FE45F306DC9C883
	.c1: DQ 0x4338000000000000, 0x4338000000000000
	.c2: DQ 0xBFF921FB54440000, 0xBFF921FB54440000
	.c3: DQ 0xBD868C234C4C8000, 0xBD868C234C4C8000
	.c4: DQ 0x3B09D747F23E32ED, 0x3B09D747F23E32ED
	.c5: DQ 0xBDA8FA87EF79AE3F, 0xBDA8FA87EF79AE3F
	.c6: DQ 0x3DE5D8711D281543, 0x3DE5D8711D281543
	.c7: DQ 0x3E21EE9DF6693F7E, 0x3E21EE9DF6693F7E
	.c8: DQ 0xBE5AE5E38936D046, 0xBE5AE5E38936D046
	.c9: DQ 0xBE927E4F7F65104F, 0xBE927E4F7F65104F
	.c10: DQ 0x3EC71DE3535C8A8A, 0x3EC71DE3535C8A8A
	.c11: DQ 0x3EFA01A019C94874, 0x3EFA01A019C94874
	.c12: DQ 0xBF2A01A019BB92C0, 0xBF2A01A019BB92C0
	.c13: DQ 0xBF56C16C16C15038, 0xBF56C16C16C15038
	.c14: DQ 0x3F8111111110F51E, 0x3F8111111110F51E
	.c15: DQ 0x3FA555555555554B, 0x3FA555555555554B
	.c16: DQ 0xBFC5555555555546, 0xBFC5555555555546
	.c17: DQ 0xBFE0000000000000, 0xBFE0000000000000
	.c18: DQ 0x3FF0000000000000, 0x3FF0000000000000
	.c19: DQ 0x8000000000000000, 0x8000000000000000
	.c20: DQ 0x3FE45F306DC9C883, 0x3FE45F306DC9C883, 0x3FE45F306DC9C883, 0x3FE45F306DC9C883
	.c21: DQ 0x4338000000000000, 0x4338000000000000, 0x4338000000000000, 0x4338000000000000
	.c22: DQ 0xBFF921FB54440000, 0xBFF921FB54440000, 0xBFF921FB54440000, 0xBFF921FB54440000
	.c23: DQ 0xBD868C234C4C8000, 0xBD868C234C4C8000, 0xBD868C234C4C8000, 0xBD868C234C4C8000
	.c24: DQ 0x3B09D747F23E32ED, 0x3B09D747F23E32ED, 0x3B09D747F23E32ED, 0x3B09D747F23E32ED
	.c25: DQ 0xBDA8FA87EF79AE3F, 0xBDA8FA87EF79AE3F, 0xBDA8FA87EF79AE3F, 0xBDA8FA87EF79AE3F
	.c26: DQ 0x3E21EE9DF6693F7E, 0x3E21EE9DF6693F7E, 0x3E21EE9DF6693F7E, 0x3E21EE9DF6693F7E
	.c27: DQ 0x3DE5D8711D281543, 0x3DE5D8711D281543, 0x3DE5D8711D281543, 0x3DE5D8711D281543
	.c28: DQ 0xBE5AE5E38936D046, 0xBE5AE5E38936D046, 0xBE5AE5E38936D046, 0xBE5AE5E38936D046
	.c29: DQ 0xBE927E4F7F65104F, 0xBE927E4F7F65104F, 0xBE927E4F7F65104F, 0xBE927E4F7F65104F
	.c30: DQ 0x3EC71DE3535C8A8A, 0x3EC71DE3535C8A8A, 0x3EC71DE3535C8A8A, 0x3EC71DE3535C8A8A
	.c31: DQ 0x3EFA01A019C94874, 0x3EFA01A019C94874, 0x3EFA01A019C94874, 0x3EFA01A019C94874
	.c32: DQ 0xBF2A01A019BB92C0, 0xBF2A01A019BB92C0, 0xBF2A01A019BB92C0, 0xBF2A01A019BB92C0
	.c33: DQ 0xBF56C16C16C15038, 0xBF56C16C16C15038, 0xBF56C16C16C15038, 0xBF56C16C16C15038
	.c34: DQ 0x3F8111111110F51E, 0x3F8111111110F51E, 0x3F8111111110F51E, 0x3F8111111110F51E
	.c35: DQ 0x3FA555555555554B, 0x3FA555555555554B, 0x3FA555555555554B, 0x3FA555555555554B
	.c36: DQ 0xBFC5555555555546, 0xBFC5555555555546, 0xBFC5555555555546, 0xBFC5555555555546
	.c37: DQ 0xBFE0000000000000, 0xBFE0000000000000, 0xBFE0000000000000, 0xBFE0000000000000
	.c38: DQ 0x3FF0000000000000, 0x3FF0000000000000, 0x3FF0000000000000, 0x3FF0000000000000
	.c39: DQ 0x8000000000000000, 0x8000000000000000, 0x8000000000000000, 0x8000000000000000


section .text.Bulldozer progbits alloc exec nowrite align=16
global _yepMath_Sin_V64f_V64f_Bulldozer
_yepMath_Sin_V64f_V64f_Bulldozer:
	.ENTRY:
	MOV rax, rsp                                                           ; 
	SUB rsp, 8                                                             ; 
	AND rsp, -32                                                           ; 
	MOV [rsp], rax                                                         ; 
	SUB rsp, 320                                                           ; 
	MOV rax, rdi                                                           ; rdi, rdx, rsi, rsp
	MOV r10, rsi                                                           ; rax, rdx, rsi, rsp
	MOV r11, rdx                                                           ; r10, rax, rdx, rsp
	CMP r11, 0                                                             ; r10, r11, rax, rsp
	JZ .returnOk                                                           ; r10, r11, rax, rsp
	TEST rax, 31                                                           ; r10, r11, rax, rsp
	JZ .source_32b_aligned                                                 ; r10, r11, rax, rsp
	.source_32b_misaligned:
	VMOVSD xmm1, [rax]                                                     ; r10, r11, rax, rsp
	VMULPD xmm2, xmm1, oword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c0] ; r10, r11, rax, rsp, xmm1
	VADDPD xmm2, xmm2, oword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c1] ; r10, r11, rax, rsp, xmm1, xmm2
	VPSLLQ xmm0, xmm2, 62                                                  ; r10, r11, rax, rsp, xmm1, xmm2
	VSUBPD xmm2, xmm2, oword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c1] ; r10, r11, rax, rsp, xmm0, xmm1, xmm2
	VMULPD xmm3, xmm2, oword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c2] ; r10, r11, rax, rsp, xmm0, xmm1, xmm2
	VADDPD xmm1, xmm1, xmm3                                                ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3
	VMOVAPS xmm4, xmm1                                                     ; r10, r11, rax, rsp, xmm0, xmm1, xmm2
	VMULPD xmm3, xmm2, oword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c3] ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm4
	VADDPD xmm1, xmm1, xmm3                                                ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VSUBPD xmm4, xmm1, xmm4                                                ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VSUBPD xmm3, xmm3, xmm4                                                ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VMULPD xmm2, xmm2, oword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c4] ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3
	VADDPD xmm2, xmm2, xmm3                                                ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3
	VADDPD xmm1, xmm1, xmm2                                                ; r10, r11, rax, rsp, xmm0, xmm1, xmm2
	VMULPD xmm4, xmm1, xmm1                                                ; r10, r11, rax, rsp, xmm0, xmm1
	VMOVAPD xmm3, oword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c5] ; 
	VMOVAPD xmm2, oword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c6] ; 
	VFMADDPD xmm3, xmm3, xmm4, oword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c7] ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VFMADDPD xmm2, xmm2, xmm4, oword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c8] ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VFMADDPD xmm3, xmm3, xmm4, oword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c9] ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VFMADDPD xmm2, xmm2, xmm4, oword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c10] ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VFMADDPD xmm3, xmm3, xmm4, oword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c11] ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VFMADDPD xmm2, xmm2, xmm4, oword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c12] ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VFMADDPD xmm3, xmm3, xmm4, oword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c13] ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VFMADDPD xmm2, xmm2, xmm4, oword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c14] ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VFMADDPD xmm3, xmm3, xmm4, oword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c15] ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VFMADDPD xmm2, xmm2, xmm4, oword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c16] ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VFMADDPD xmm3, xmm3, xmm4, oword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c17] ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VMULPD xmm2, xmm2, xmm4                                                ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VFMADDPD xmm3, xmm3, xmm4, oword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c18] ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VFMADDPD xmm2, xmm2, xmm1, xmm1                                        ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3
	VMOVAPD xmm1, oword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c19] ; 
	VPAND xmm1, xmm1, xmm0                                                 ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3
	VPADDQ xmm0, xmm0, xmm0                                                ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3
	VBLENDVPD xmm2, xmm2, xmm3, xmm0                                       ; r10, r11, rax, rsp, xmm0, xmm1, xmm2, xmm3
	VXORPD xmm2, xmm2, xmm1                                                ; r10, r11, rax, rsp, xmm1, xmm2
	VMOVSD [r10], xmm2                                                     ; r10, r11, rax, rsp, xmm2
	ADD rax, 8                                                             ; r10, r11, rax, rsp
	ADD r10, 8                                                             ; r10, r11, rax, rsp
	SUB r11, 1                                                             ; r10, r11, rax, rsp
	JZ .returnOk                                                           ; r10, r11, rax, rsp
	TEST rax, 31                                                           ; r10, r11, rax, rsp
	JNZ .source_32b_misaligned                                             ; r10, r11, rax, rsp
	.source_32b_aligned:
	SUB r11, 20                                                            ; r10, r11, rax, rsp
	JB .process_restore                                                    ; r10, r11, rax, rsp
	align 32
	.process_batch:
	VMOVAPS ymm1, yword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c20] ; 
	VMOVAPS ymm10, yword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c21] ; 
	VMOVAPD ymm9, [rax]                                                    ; r10, r11, rax, rsp, ymm1, ymm10
	VMULPD ymm8, ymm9, ymm1                                                ; r10, r11, rax, rsp, ymm1, ymm10, ymm9
	VADDPD ymm8, ymm8, ymm10                                               ; r10, r11, rax, rsp, ymm1, ymm10, ymm8, ymm9
	VMOVAPD ymm7, [byte rax + 32]                                          ; r10, r11, rax, rsp, ymm1, ymm10, ymm8, ymm9
	VMULPD ymm6, ymm7, ymm1                                                ; r10, r11, rax, rsp, ymm1, ymm10, ymm7, ymm8, ymm9
	VADDPD ymm6, ymm6, ymm10                                               ; r10, r11, rax, rsp, ymm1, ymm10, ymm6, ymm7, ymm8, ymm9
	VMOVAPD ymm5, [byte rax + 64]                                          ; r10, r11, rax, rsp, ymm1, ymm10, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm4, ymm5, ymm1                                                ; r10, r11, rax, rsp, ymm1, ymm10, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm4, ymm4, ymm10                                               ; r10, r11, rax, rsp, ymm1, ymm10, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVAPD ymm3, [byte rax + 96]                                          ; r10, r11, rax, rsp, ymm1, ymm10, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm2, ymm3, ymm1                                                ; r10, r11, rax, rsp, ymm1, ymm10, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm2, ymm2, ymm10                                               ; r10, r11, rax, rsp, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVAPD ymm0, [dword rax + 128]                                        ; r10, r11, rax, rsp, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm1, ymm0, ymm1                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm1, ymm1, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VEXTRACTF128 xmm12, ymm8, 1                                            ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VPSLLQ xmm11, xmm8, 62                                                 ; r10, r11, rax, rsp, xmm12, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVDQA oword [rsp + 160], xmm11                                       ; r10, r11, rax, rsp, xmm11, xmm12, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VPSLLQ xmm12, xmm12, 62                                                ; r10, r11, rax, rsp, xmm12, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVDQA oword [rsp + 176], xmm12                                       ; r10, r11, rax, rsp, xmm12, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VSUBPD ymm8, ymm8, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VEXTRACTF128 xmm12, ymm6, 1                                            ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VPSLLQ xmm11, xmm6, 62                                                 ; r10, r11, rax, rsp, xmm12, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVDQA oword [rsp + 192], xmm11                                       ; r10, r11, rax, rsp, xmm11, xmm12, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VPSLLQ xmm12, xmm12, 62                                                ; r10, r11, rax, rsp, xmm12, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVDQA oword [rsp + 208], xmm12                                       ; r10, r11, rax, rsp, xmm12, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VSUBPD ymm6, ymm6, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VEXTRACTF128 xmm12, ymm4, 1                                            ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VPSLLQ xmm11, xmm4, 62                                                 ; r10, r11, rax, rsp, xmm12, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVDQA oword [rsp + 224], xmm11                                       ; r10, r11, rax, rsp, xmm11, xmm12, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VPSLLQ xmm12, xmm12, 62                                                ; r10, r11, rax, rsp, xmm12, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVDQA oword [rsp + 240], xmm12                                       ; r10, r11, rax, rsp, xmm12, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VSUBPD ymm4, ymm4, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VEXTRACTF128 xmm11, ymm2, 1                                            ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VPSLLQ xmm12, xmm2, 62                                                 ; r10, r11, rax, rsp, xmm11, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVDQA oword [rsp + 256], xmm12                                       ; r10, r11, rax, rsp, xmm11, xmm12, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VPSLLQ xmm11, xmm11, 62                                                ; r10, r11, rax, rsp, xmm11, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVDQA oword [rsp + 272], xmm11                                       ; r10, r11, rax, rsp, xmm11, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VSUBPD ymm2, ymm2, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VEXTRACTF128 xmm12, ymm1, 1                                            ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VPSLLQ xmm11, xmm1, 62                                                 ; r10, r11, rax, rsp, xmm12, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVDQA oword [rsp + 288], xmm11                                       ; r10, r11, rax, rsp, xmm11, xmm12, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VPSLLQ xmm12, xmm12, 62                                                ; r10, r11, rax, rsp, xmm12, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVDQA oword [rsp + 304], xmm12                                       ; r10, r11, rax, rsp, xmm12, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VSUBPD ymm1, ymm1, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm10, ymm8, yword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c22] ; r10, r11, rax, rsp, ymm0, ymm1, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm9, ymm9, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm10, ymm6, yword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c22] ; r10, r11, rax, rsp, ymm0, ymm1, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm7, ymm7, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm10, ymm4, yword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c22] ; r10, r11, rax, rsp, ymm0, ymm1, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm5, ymm5, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm10, ymm2, yword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c22] ; r10, r11, rax, rsp, ymm0, ymm1, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm3, ymm3, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm10, ymm1, yword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c22] ; r10, r11, rax, rsp, ymm0, ymm1, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm0, ymm0, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm11, ymm8, yword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c23] ; r10, r11, rax, rsp, ymm0, ymm1, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VADDPD ymm10, ymm9, ymm11                                              ; r10, r11, rax, rsp, ymm0, ymm1, ymm11, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VSUBPD ymm9, ymm10, ymm9                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VSUBPD ymm11, ymm11, ymm9                                              ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm8, ymm8, yword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c24] ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8
	VADDPD ymm8, ymm8, ymm11                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8
	VADDPD ymm10, ymm10, ymm8                                              ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8
	VMULPD ymm9, ymm6, yword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c23] ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7
	VADDPD ymm8, ymm7, ymm9                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm9
	VSUBPD ymm7, ymm8, ymm7                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VSUBPD ymm9, ymm9, ymm7                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm6, ymm6, yword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c24] ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm8, ymm9
	VADDPD ymm6, ymm6, ymm9                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm8, ymm9
	VADDPD ymm8, ymm8, ymm6                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm8
	VMULPD ymm7, ymm4, yword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c23] ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm8
	VADDPD ymm6, ymm5, ymm7                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm7, ymm8
	VSUBPD ymm5, ymm6, ymm5                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8
	VSUBPD ymm7, ymm7, ymm5                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8
	VMULPD ymm4, ymm4, yword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c24] ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm6, ymm7, ymm8
	VADDPD ymm4, ymm4, ymm7                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm6, ymm7, ymm8
	VADDPD ymm6, ymm6, ymm4                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm6, ymm8
	VMULPD ymm5, ymm2, yword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c23] ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm6, ymm8
	VADDPD ymm4, ymm3, ymm5                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm5, ymm6, ymm8
	VSUBPD ymm3, ymm4, ymm3                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm8
	VSUBPD ymm5, ymm5, ymm3                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm8
	VMULPD ymm2, ymm2, yword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c24] ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm4, ymm5, ymm6, ymm8
	VADDPD ymm2, ymm2, ymm5                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm4, ymm5, ymm6, ymm8
	VADDPD ymm4, ymm4, ymm2                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm4, ymm6, ymm8
	VMULPD ymm3, ymm1, yword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c23] ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm4, ymm6, ymm8
	VADDPD ymm2, ymm0, ymm3                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm3, ymm4, ymm6, ymm8
	VSUBPD ymm0, ymm2, ymm0                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm6, ymm8
	VSUBPD ymm3, ymm3, ymm0                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm6, ymm8
	VMULPD ymm1, ymm1, yword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c24] ; r10, r11, rax, rsp, ymm1, ymm10, ymm2, ymm3, ymm4, ymm6, ymm8
	VADDPD ymm1, ymm1, ymm3                                                ; r10, r11, rax, rsp, ymm1, ymm10, ymm2, ymm3, ymm4, ymm6, ymm8
	VADDPD ymm2, ymm2, ymm1                                                ; r10, r11, rax, rsp, ymm1, ymm10, ymm2, ymm4, ymm6, ymm8
	VMOVAPD yword [rsp], ymm10                                             ; r10, r11, rax, rsp, ymm10, ymm2, ymm4, ymm6, ymm8
	VMULPD ymm12, ymm10, ymm10                                             ; r10, r11, rax, rsp, ymm10, ymm2, ymm4, ymm6, ymm8
	VMOVAPD yword [rsp + 32], ymm8                                         ; r10, r11, rax, rsp, ymm12, ymm2, ymm4, ymm6, ymm8
	VMULPD ymm14, ymm8, ymm8                                               ; r10, r11, rax, rsp, ymm12, ymm2, ymm4, ymm6, ymm8
	VMOVAPD yword [rsp + 64], ymm6                                         ; r10, r11, rax, rsp, ymm12, ymm14, ymm2, ymm4, ymm6
	VMULPD ymm10, ymm6, ymm6                                               ; r10, r11, rax, rsp, ymm12, ymm14, ymm2, ymm4, ymm6
	VMOVAPD yword [rsp + 96], ymm4                                         ; r10, r11, rax, rsp, ymm10, ymm12, ymm14, ymm2, ymm4
	VMULPD ymm11, ymm4, ymm4                                               ; r10, r11, rax, rsp, ymm10, ymm12, ymm14, ymm2, ymm4
	VMOVAPD yword [rsp + 128], ymm2                                        ; r10, r11, rax, rsp, ymm10, ymm11, ymm12, ymm14, ymm2
	VMULPD ymm13, ymm2, ymm2                                               ; r10, r11, rax, rsp, ymm10, ymm11, ymm12, ymm14, ymm2
	VMOVAPS ymm0, yword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c25] ; 
	VMOVAPS ymm2, yword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c26] ; 
	VFMADDPD ymm8, ymm0, ymm12, ymm2                                       ; r10, r11, rax, rsp, ymm0, ymm10, ymm11, ymm12, ymm13, ymm14, ymm2
	VFMADDPD ymm6, ymm0, ymm14, ymm2                                       ; r10, r11, rax, rsp, ymm0, ymm10, ymm11, ymm12, ymm13, ymm14, ymm2, ymm8
	VFMADDPD ymm3, ymm0, ymm10, ymm2                                       ; r10, r11, rax, rsp, ymm0, ymm10, ymm11, ymm12, ymm13, ymm14, ymm2, ymm6, ymm8
	VFMADDPD ymm1, ymm0, ymm11, ymm2                                       ; r10, r11, rax, rsp, ymm0, ymm10, ymm11, ymm12, ymm13, ymm14, ymm2, ymm3, ymm6, ymm8
	VFMADDPD ymm0, ymm0, ymm13, ymm2                                       ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm2, ymm3, ymm6, ymm8
	VMOVAPS ymm15, yword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c27] ; 
	VMOVAPS ymm4, yword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c28] ; 
	VFMADDPD ymm9, ymm15, ymm12, ymm4                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm3, ymm4, ymm6, ymm8
	VFMADDPD ymm7, ymm15, ymm14, ymm4                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm3, ymm4, ymm6, ymm8, ymm9
	VFMADDPD ymm5, ymm15, ymm10, ymm4                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm3, ymm4, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm2, ymm15, ymm11, ymm4                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm4, ymm15, ymm13, ymm4                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVAPS ymm15, yword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c29] ; 
	VFMADDPD ymm8, ymm8, ymm12, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm6, ymm6, ymm14, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm3, ymm3, ymm10, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm1, ymm1, ymm11, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm0, ymm0, ymm13, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVAPS ymm15, yword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c30] ; 
	VFMADDPD ymm9, ymm9, ymm12, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm7, ymm7, ymm14, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm5, ymm5, ymm10, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm2, ymm2, ymm11, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm4, ymm4, ymm13, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVAPS ymm15, yword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c31] ; 
	VFMADDPD ymm8, ymm8, ymm12, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm6, ymm6, ymm14, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm3, ymm3, ymm10, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm1, ymm1, ymm11, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm0, ymm0, ymm13, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVAPS ymm15, yword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c32] ; 
	VFMADDPD ymm9, ymm9, ymm12, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm7, ymm7, ymm14, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm5, ymm5, ymm10, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm2, ymm2, ymm11, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm4, ymm4, ymm13, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVAPS ymm15, yword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c33] ; 
	VFMADDPD ymm8, ymm8, ymm12, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm6, ymm6, ymm14, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm3, ymm3, ymm10, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm1, ymm1, ymm11, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm0, ymm0, ymm13, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVAPS ymm15, yword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c34] ; 
	VFMADDPD ymm9, ymm9, ymm12, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm7, ymm7, ymm14, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm5, ymm5, ymm10, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm2, ymm2, ymm11, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm4, ymm4, ymm13, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVAPS ymm15, yword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c35] ; 
	VFMADDPD ymm8, ymm8, ymm12, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm6, ymm6, ymm14, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm3, ymm3, ymm10, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm1, ymm1, ymm11, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm0, ymm0, ymm13, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVAPS ymm15, yword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c36] ; 
	VFMADDPD ymm9, ymm9, ymm12, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm7, ymm7, ymm14, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm5, ymm5, ymm10, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm2, ymm2, ymm11, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm4, ymm4, ymm13, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVAPS ymm15, yword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c37] ; 
	VFMADDPD ymm8, ymm8, ymm12, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm6, ymm6, ymm14, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm3, ymm3, ymm10, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm1, ymm1, ymm11, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm0, ymm0, ymm13, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVAPS ymm15, yword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c38] ; 
	VMULPD ymm9, ymm9, ymm12                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm8, ymm8, ymm12, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVAPD ymm12, yword [rsp]                                             ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm9, ymm9, ymm12, ymm12                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm7, ymm7, ymm14                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm6, ymm6, ymm14, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm13, ymm14, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVAPD ymm12, yword [rsp + 32]                                        ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm13, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm7, ymm7, ymm12, ymm12                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm13, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm5, ymm5, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm13, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm3, ymm3, ymm10, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm13, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVAPD ymm10, yword [rsp + 64]                                        ; r10, r11, rax, rsp, ymm0, ymm1, ymm11, ymm13, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm5, ymm5, ymm10, ymm10                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm13, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm2, ymm2, ymm11                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm11, ymm13, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm1, ymm1, ymm11, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm11, ymm13, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVAPD ymm10, yword [rsp + 96]                                        ; r10, r11, rax, rsp, ymm0, ymm1, ymm13, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm2, ymm2, ymm10, ymm10                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm13, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMULPD ymm4, ymm4, ymm13                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm13, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm0, ymm0, ymm13, ymm15                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm13, ymm15, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVAPD ymm10, yword [rsp + 128]                                       ; r10, r11, rax, rsp, ymm0, ymm1, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VFMADDPD ymm4, ymm4, ymm10, ymm10                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VMOVAPS ymm10, yword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c39] ; 
	VMOVAPD ymm11, yword [rsp + 160]                                       ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VANDPD ymm12, ymm11, ymm10                                             ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VANDNPD ymm11, ymm10, ymm11                                            ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VCMPEQPD ymm11, ymm11, ymm12                                           ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VBLENDVPD ymm9, ymm8, ymm9, ymm11                                      ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm11, ymm12, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VXORPD ymm9, ymm9, ymm12                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm12, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm9
	VMOVUPD [r10], xmm9                                                    ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm9
	VEXTRACTF128 [byte r10 + 16], ymm9, 1                                  ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm9
	VMOVAPD ymm8, yword [rsp + 192]                                        ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7
	VANDPD ymm9, ymm8, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8
	VANDNPD ymm8, ymm10, ymm8                                              ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VCMPEQPD ymm8, ymm8, ymm9                                              ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VBLENDVPD ymm7, ymm6, ymm7, ymm8                                       ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7, ymm8, ymm9
	VXORPD ymm7, ymm7, ymm9                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm7, ymm9
	VMOVUPD [byte r10 + 32], xmm7                                          ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm7
	VEXTRACTF128 [byte r10 + 48], ymm7, 1                                  ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm7
	VMOVAPD ymm7, yword [rsp + 224]                                        ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5
	VANDPD ymm6, ymm7, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm7
	VANDNPD ymm7, ymm10, ymm7                                              ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7
	VCMPEQPD ymm7, ymm7, ymm6                                              ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7
	VBLENDVPD ymm5, ymm3, ymm5, ymm7                                       ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5, ymm6, ymm7
	VXORPD ymm5, ymm5, ymm6                                                ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm4, ymm5, ymm6
	VMOVUPD [byte r10 + 64], xmm5                                          ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm4, ymm5
	VEXTRACTF128 [byte r10 + 80], ymm5, 1                                  ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm4, ymm5
	VMOVAPD ymm5, yword [rsp + 256]                                        ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm4
	VANDPD ymm3, ymm5, ymm10                                               ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm4, ymm5
	VANDNPD ymm5, ymm10, ymm5                                              ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5
	VCMPEQPD ymm5, ymm5, ymm3                                              ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5
	VBLENDVPD ymm2, ymm1, ymm2, ymm5                                       ; r10, r11, rax, rsp, ymm0, ymm1, ymm10, ymm2, ymm3, ymm4, ymm5
	VXORPD ymm2, ymm2, ymm3                                                ; r10, r11, rax, rsp, ymm0, ymm10, ymm2, ymm3, ymm4
	VMOVUPD [byte r10 + 96], xmm2                                          ; r10, r11, rax, rsp, ymm0, ymm10, ymm2, ymm4
	VEXTRACTF128 [byte r10 + 112], ymm2, 1                                 ; r10, r11, rax, rsp, ymm0, ymm10, ymm2, ymm4
	VMOVAPD ymm1, yword [rsp + 288]                                        ; r10, r11, rax, rsp, ymm0, ymm10, ymm4
	VANDPD ymm2, ymm1, ymm10                                               ; r10, r11, rax, ymm0, ymm1, ymm10, ymm4
	VANDNPD ymm1, ymm10, ymm1                                              ; r10, r11, rax, ymm0, ymm1, ymm10, ymm2, ymm4
	VCMPEQPD ymm1, ymm1, ymm2                                              ; r10, r11, rax, ymm0, ymm1, ymm2, ymm4
	VBLENDVPD ymm4, ymm0, ymm4, ymm1                                       ; r10, r11, rax, ymm0, ymm1, ymm2, ymm4
	VXORPD ymm4, ymm4, ymm2                                                ; r10, r11, rax, ymm2, ymm4
	VMOVUPD [dword r10 + 128], xmm4                                        ; r10, r11, rax, ymm4
	VEXTRACTF128 [dword r10 + 144], ymm4, 1                                ; r10, r11, rax, ymm4
	ADD rax, 160                                                           ; r10, r11, rax
	ADD r10, 160                                                           ; r10, r11, rax
	SUB r11, 20                                                            ; r10, r11, rax
	JAE .process_batch                                                     ; r10, r11, rax
	.process_restore:
	ADD r11, 20                                                            ; r10, r11, rax
	JZ .returnOk                                                           ; r10, r11, rax
	.process_single:
	VMOVSD xmm1, [rax]                                                     ; r10, r11, rax
	VMULPD xmm2, xmm1, oword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c0] ; r10, r11, rax, xmm1
	VADDPD xmm2, xmm2, oword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c1] ; r10, r11, rax, xmm1, xmm2
	VPSLLQ xmm0, xmm2, 62                                                  ; r10, r11, rax, xmm1, xmm2
	VSUBPD xmm2, xmm2, oword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c1] ; r10, r11, rax, xmm0, xmm1, xmm2
	VMULPD xmm3, xmm2, oword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c2] ; r10, r11, rax, xmm0, xmm1, xmm2
	VADDPD xmm1, xmm1, xmm3                                                ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3
	VMOVAPS xmm4, xmm1                                                     ; r10, r11, rax, xmm0, xmm1, xmm2
	VMULPD xmm3, xmm2, oword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c3] ; r10, r11, rax, xmm0, xmm1, xmm2, xmm4
	VADDPD xmm1, xmm1, xmm3                                                ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VSUBPD xmm4, xmm1, xmm4                                                ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VSUBPD xmm3, xmm3, xmm4                                                ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VMULPD xmm2, xmm2, oword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c4] ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3
	VADDPD xmm2, xmm2, xmm3                                                ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3
	VADDPD xmm1, xmm1, xmm2                                                ; r10, r11, rax, xmm0, xmm1, xmm2
	VMULPD xmm4, xmm1, xmm1                                                ; r10, r11, rax, xmm0, xmm1
	VMOVAPD xmm3, oword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c5] ; 
	VMOVAPD xmm2, oword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c6] ; 
	VFMADDPD xmm3, xmm3, xmm4, oword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c7] ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VFMADDPD xmm2, xmm2, xmm4, oword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c8] ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VFMADDPD xmm3, xmm3, xmm4, oword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c9] ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VFMADDPD xmm2, xmm2, xmm4, oword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c10] ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VFMADDPD xmm3, xmm3, xmm4, oword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c11] ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VFMADDPD xmm2, xmm2, xmm4, oword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c12] ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VFMADDPD xmm3, xmm3, xmm4, oword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c13] ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VFMADDPD xmm2, xmm2, xmm4, oword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c14] ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VFMADDPD xmm3, xmm3, xmm4, oword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c15] ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VFMADDPD xmm2, xmm2, xmm4, oword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c16] ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VFMADDPD xmm3, xmm3, xmm4, oword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c17] ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VMULPD xmm2, xmm2, xmm4                                                ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VFMADDPD xmm3, xmm3, xmm4, oword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c18] ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3, xmm4
	VFMADDPD xmm2, xmm2, xmm1, xmm1                                        ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3
	VMOVAPD xmm1, oword[rel _yepMath_Sin_V64f_V64f_Bulldozer_constants.c19] ; 
	VPAND xmm1, xmm1, xmm0                                                 ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3
	VPADDQ xmm0, xmm0, xmm0                                                ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3
	VBLENDVPD xmm2, xmm2, xmm3, xmm0                                       ; r10, r11, rax, xmm0, xmm1, xmm2, xmm3
	VXORPD xmm2, xmm2, xmm1                                                ; r10, r11, rax, xmm1, xmm2
	VMOVSD [r10], xmm2                                                     ; r10, r11, rax, xmm2
	ADD rax, 8                                                             ; r10, r11, rax
	ADD r10, 8                                                             ; r10, r11
	SUB r11, 1                                                             ; r11
	JNZ .process_single                                                    ; 
	.returnOk:
	MOV rsp, [dword rsp + 320]                                             ; 
	XOR eax, eax                                                           ; 
	RET                                                                    ; 
